/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      return 0;

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      return 1;

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      return 2;

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      return 3;

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 4;

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      return 5;

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      return 6;

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      return 7;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 8;

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      return 9;

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      return 10;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 11;

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      return 12;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 13;

    case E_V1SFmode:
      if (!register_operand (operands[0], E_V1SFmode)
          || GET_MODE (x3) != E_V1SFmode
          || !register_operand (operands[1], E_V1SFmode))
        return -1;
      return 14;

    case E_V2SFmode:
      if (!register_operand (operands[0], E_V2SFmode)
          || GET_MODE (x3) != E_V2SFmode
          || !register_operand (operands[1], E_V2SFmode))
        return -1;
      return 15;

    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x3) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 16;

    case E_V1DFmode:
      if (!register_operand (operands[0], E_V1DFmode)
          || GET_MODE (x3) != E_V1DFmode
          || !register_operand (operands[1], E_V1DFmode))
        return -1;
      return 17;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x3) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 18;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x3) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 19;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || GET_MODE (x3) != E_V1TImode
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 20;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || GET_MODE (x3) != E_TImode
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 21;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 22;

    default:
      return -1;
    }
}

int
pattern50 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != E_TImode
      || !register_operand (operands[0], E_TImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  if (!register_operand (operands[1], i1))
    return -1;
  x3 = XVECEXP (x1, 0, 1);
  operands[2] = x3;
  if (!register_operand (operands[2], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  operands[3] = x4;
  if (!register_operand (operands[3], E_TImode))
    return -1;
  return 0;
}

int
pattern56 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CONST_INT)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  operands[1] = x3;
  x4 = XVECEXP (x1, 0, 1);
  operands[2] = x4;
  switch (XWINT (x2, 0))
    {
    case 0L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          return pattern19 (x1, 
E_V16QImode); /* [-1, 0] */

        case E_V8HImode:
          if (pattern19 (x1, 
E_V8HImode) != 0)
            return -1;
          return 1;

        case E_V4SImode:
          if (pattern19 (x1, 
E_V4SImode) != 0)
            return -1;
          return 2;

        default:
          return -1;
        }

    case 2L:
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern19 (x1, 
E_V16QImode) != 0)
            return -1;
          return 3;

        case E_V8HImode:
          if (pattern19 (x1, 
E_V8HImode) != 0)
            return -1;
          return 4;

        case E_V4SImode:
          if (pattern19 (x1, 
E_V4SImode) != 0)
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern70 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 16)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x6) != USE)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_SImode)
    return -1;
  return pattern69 (x2); /* [-1, 23] */
}

int
pattern77 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || GET_MODE (x1) != i1
      || !scratch_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern83 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern84 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !memory_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern91 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonzero_shift_count_operand (operands[3], i1)
      || !contiguous_bitmask_nowrap_operand (operands[2], i1)
      || !nonimmediate_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern100 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[3], i2)
      || !const0_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern106 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i2
      || !register_operand (operands[2], i1)
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern111 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[1]))
    {
    case E_TImode:
      if (!register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !register_operand (operands[2], E_TFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (!rtx_equal_p (x4, operands[0]))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE
      || !memory_operand (operands[0], E_BLKmode)
      || GET_MODE (x3) != E_BLKmode)
    return -1;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  if (!memory_operand (operands[1], E_BLKmode))
    return -1;
  x7 = XEXP (x5, 0);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  return 0;
}

int
pattern127 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[2], i1)
      || GET_CODE (x1) != SET)
    return -1;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != COMPARE)
    return -1;
  x3 = XEXP (x1, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33)
    return -1;
  x4 = XEXP (x2, 1);
  operands[1] = x4;
  if (!const0_operand (operands[1], i1))
    return -1;
  x5 = XEXP (x2, 0);
  if (!rtx_equal_p (x5, operands[0]))
    return -1;
  return 0;
}

int
pattern135 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode)
          || !const0_operand (operands[2], E_TFmode))
        return -1;
      return 0;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode)
          || !const0_operand (operands[2], E_FPRX2mode))
        return -1;
      return 1;

    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode)
          || !const0_operand (operands[2], E_DFmode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode)
          || !const0_operand (operands[2], E_SFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern145 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  return 0;
}

int
pattern149 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_MODE (x4) != E_DImode
      || !immediate_operand (operands[2], E_DImode))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!register_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_TFmode:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      return 1;

    case E_FPRX2mode:
      if (!register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 2;

    case E_SFmode:
      if (!register_operand (operands[1], E_SFmode))
        return -1;
      return 3;

    case E_TDmode:
      if (!register_operand (operands[1], E_TDmode))
        return -1;
      return 4;

    case E_DDmode:
      if (!register_operand (operands[1], E_DDmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern159 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern166 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      return 0;

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      return 1;

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      return 2;

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      return 3;

    case E_V1TImode:
      if (!register_operand (operands[0], E_V1TImode)
          || !register_operand (operands[1], E_V1TImode))
        return -1;
      return 4;

    case E_TImode:
      if (!register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern184 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  if (GET_MODE (x2) != i2
      || !memory_operand (operands[1], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern188 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1)
      || !nonimmediate_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern195 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_CODE (operands[2]))
    {
    case CONST_INT:
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      operands[3] = x5;
      if (!immediate_operand (operands[3], E_VOIDmode))
        return -1;
      x6 = XVECEXP (x1, 0, 3);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_VOIDmode))
        return -1;
      return 0;

    case REG:
    case SUBREG:
      if (!register_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      x5 = XEXP (x4, 0);
      switch (GET_CODE (x5))
        {
        case SUBREG:
        case MEM:
          operands[3] = x5;
          if (!memory_operand (operands[3], E_VOIDmode))
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[4] = x7;
          if (!scratch_operand (operands[4], E_VOIDmode))
            return -1;
          return 1;

        case CONST:
          if (GET_MODE (x5) != E_BLKmode)
            return -1;
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != UNSPEC
              || XVECLEN (x8, 0) != 1
              || XINT (x8, 1) != 17
              || GET_MODE (x8) != E_BLKmode)
            return -1;
          x9 = XVECEXP (x8, 0, 0);
          if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          x6 = XVECEXP (x1, 0, 3);
          x7 = XEXP (x6, 0);
          operands[3] = x7;
          return 2;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern224 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[1], i1)
      || !general_operand (operands[2], i1))
    return -1;
  operands[3] = x1;
  if (!const0_operand (operands[3], i1)
      || !scratch_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern234 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode)
          || !scratch_operand (operands[2], E_V4SImode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode)
          || !scratch_operand (operands[2], E_V2DImode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode)
          || !scratch_operand (operands[2], E_V1TImode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode)
          || !scratch_operand (operands[2], E_TImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern252 (rtx x1, rtx_code i1, rtx_code i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != i2
      || GET_MODE (x1) != E_DImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != i1
      || GET_MODE (x2) != E_DImode)
    return -1;
  return 0;
}

int
pattern261 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !const0_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern270 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern280 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (XINT (x3, 1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern279 (x5, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern279 (x5, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern279 (x5, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern295 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || !register_operand (operands[1], i1))
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2
      || !register_operand (operands[2], i1))
    return -1;
  x4 = XEXP (x1, 1);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

 int
recog_4 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 307; /* vec_srlv16qiv16qi */

    case 1:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 317; /* vec_srlv16qiv8hi */

    case 2:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 327; /* vec_srlv16qiv4si */

    case 3:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 308; /* vec_srlv8hiv16qi */

    case 4:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 318; /* vec_srlv8hiv8hi */

    case 5:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 328; /* vec_srlv8hiv4si */

    case 6:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 309; /* vec_srlv4siv16qi */

    case 7:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 319; /* vec_srlv4siv8hi */

    case 8:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 329; /* vec_srlv4siv4si */

    case 9:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 310; /* vec_srlv2div16qi */

    case 10:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 320; /* vec_srlv2div8hi */

    case 11:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 330; /* vec_srlv2div4si */

    case 12:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 311; /* vec_srlv1tiv16qi */

    case 13:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 321; /* vec_srlv1tiv8hi */

    case 14:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 331; /* vec_srlv1tiv4si */

    case 15:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 312; /* vec_srltiv16qi */

    case 16:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 322; /* vec_srltiv8hi */

    case 17:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 332; /* vec_srltiv4si */

    case 18:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 313; /* vec_srlv4sfv16qi */

    case 19:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 323; /* vec_srlv4sfv8hi */

    case 20:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 333; /* vec_srlv4sfv4si */

    case 21:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 314; /* vec_srlv2dfv16qi */

    case 22:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 324; /* vec_srlv2dfv8hi */

    case 23:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 334; /* vec_srlv2dfv4si */

    case 24:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 315; /* vec_srlv1tfv16qi */

    case 25:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 325; /* vec_srlv1tfv8hi */

    case 26:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 335; /* vec_srlv1tfv4si */

    case 27:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 316; /* vec_srltfv16qi */

    case 28:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 326; /* vec_srltfv8hi */

    case 29:
      if (!
#line 1142 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
        return -1;
      return 336; /* vec_srltfv4si */

    default:
      return -1;
    }
}

 int
recog_19 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != PLUS)
    return -1;
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case ZERO_EXTEND:
      if (pattern164 (x1, 
E_V4SImode, 
E_DImode, 
E_SImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (GET_MODE (x5) != E_SImode
              || !register_operand (operands[0], E_V4SImode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 38; /* vec_scatter_elementv4si_DI */

        case E_SFmode:
          if (GET_MODE (x5) != E_SFmode
              || !register_operand (operands[0], E_V4SFmode)
              || !
#line 450 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && TARGET_64BIT && UINTVAL (operands[3]) < 4))
            return -1;
          return 39; /* vec_scatter_elementv4sf_DI */

        default:
          return -1;
        }

    case SUBREG:
      if (maybe_ne (SUBREG_BYTE (x7), 4)
          || pattern164 (x1, 
E_V2DImode, 
E_SImode, 
E_DImode) != 0)
        return -1;
      switch (GET_MODE (x2))
        {
        case E_DImode:
          if (GET_MODE (x5) != E_DImode
              || !register_operand (operands[0], E_V2DImode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 40; /* vec_scatter_elementv2di_SI */

        case E_DFmode:
          if (GET_MODE (x5) != E_DFmode
              || !register_operand (operands[0], E_V2DFmode)
              || !
#line 466 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && !TARGET_64BIT && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 41; /* vec_scatter_elementv2df_SI */

        default:
          return -1;
        }

    case VEC_SELECT:
      x8 = XEXP (x7, 1);
      if (GET_CODE (x8) != PARALLEL
          || XVECLEN (x8, 0) != 1)
        return -1;
      x9 = XEXP (x7, 0);
      operands[1] = x9;
      x10 = XVECEXP (x8, 0, 0);
      operands[3] = x10;
      if (!const_mask_operand (operands[3], E_QImode)
          || !address_operand (operands[2], E_DImode))
        return -1;
      x11 = XEXP (x5, 1);
      x12 = XVECEXP (x11, 0, 0);
      if (!rtx_equal_p (x12, operands[3]))
        return -1;
      switch (GET_MODE (x2))
        {
        case E_SImode:
          if (pattern266 (x1, 
E_V4SImode, 
E_SImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SImode)))
            return -1;
          return 42; /* vec_scatter_elementv4si_SI */

        case E_DImode:
          if (pattern266 (x1, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DImode)))
            return -1;
          return 43; /* vec_scatter_elementv2di_DI */

        case E_DFmode:
          if (pattern267 (x1, 
E_V2DFmode, 
E_DFmode, 
E_V2DImode, 
E_DImode) != 0
              || !
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V2DFmode)))
            return -1;
          return 44; /* vec_scatter_elementv2df_DI */

        case E_SFmode:
          if (pattern267 (x1, 
E_V4SFmode, 
E_SFmode, 
E_V4SImode, 
E_SImode) != 0
              || !(
#line 482 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX && UINTVAL (operands[3]) < GET_MODE_NUNITS (V4SFmode)) && 
#line 23 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VXE)))
            return -1;
          return 45; /* vec_scatter_elementv4sf_SI */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0]
          || GET_MODE (x3) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      operands[2] = x6;
      if (!general_operand (operands[2], E_SImode))
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!register_operand (operands[1], E_DImode)
          || !
#line 6139 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode) && TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2211; /* *adddi3_zero_cconly */

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (nonimmediate_operand (operands[1], E_DImode)
              && general_operand (operands[2], E_DImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && (
#line 6265 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2219; /* *adddi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && (
#line 6305 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                {
                  *pnum_clobbers = 1;
                  return 2223; /* *adddi3_carry2_cconly */
                }
            }
          break;

        case E_SImode:
          if (nonimmediate_operand (operands[1], E_SImode)
              && general_operand (operands[2], E_SImode))
            {
              x5 = XEXP (x2, 1);
              if (rtx_equal_p (x5, operands[1])
                  && 
#line 6265 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2220; /* *addsi3_carry1_cconly */
                }
              if (rtx_equal_p (x5, operands[2])
                  && 
#line 6305 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
                {
                  *pnum_clobbers = 1;
                  return 2224; /* *addsi3_carry2_cconly */
                }
            }
          break;

        case E_TFmode:
          if (nonimmediate_operand (operands[1], E_TFmode)
              && general_operand (operands[2], E_TFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TFmode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2250; /* *addtf3_cconly */
                }
            }
          break;

        case E_FPRX2mode:
          if (nonimmediate_operand (operands[1], E_FPRX2mode)
              && general_operand (operands[2], E_FPRX2mode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_FPRX2mode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
                {
                  *pnum_clobbers = 1;
                  return 2251; /* *addfprx23_cconly */
                }
            }
          break;

        case E_DFmode:
          if (nonimmediate_operand (operands[1], E_DFmode)
              && general_operand (operands[2], E_DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DFmode)
                  && 
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2252; /* *adddf3_cconly */
                }
            }
          break;

        case E_SFmode:
          if (nonimmediate_operand (operands[1], E_SFmode)
              && general_operand (operands[2], E_SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_SFmode)
                  && 
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT))
                {
                  *pnum_clobbers = 1;
                  return 2253; /* *addsf3_cconly */
                }
            }
          break;

        case E_TDmode:
          if (nonimmediate_operand (operands[1], E_TDmode)
              && general_operand (operands[2], E_TDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_TDmode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2254; /* *addtd3_cconly */
                }
            }
          break;

        case E_DDmode:
          if (nonimmediate_operand (operands[1], E_DDmode)
              && general_operand (operands[2], E_DDmode))
            {
              x5 = XEXP (x2, 1);
              operands[3] = x5;
              if (const0_operand (operands[3], E_DDmode)
                  && (
#line 6526 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCSmode) && TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
                {
                  *pnum_clobbers = 1;
                  return 2255; /* *adddd3_cconly */
                }
            }
          break;

        default:
          break;
        }
      x5 = XEXP (x2, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
        return -1;
      switch (pattern154 (x3))
        {
        case 0:
          if (!(
#line 6345 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2227; /* *adddi3_cconly */

        case 1:
          if (!
#line 6345 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCLmode)))
            return -1;
          *pnum_clobbers = 1;
          return 2228; /* *addsi3_cconly */

        default:
          return -1;
        }

    case PLUS:
      x6 = XEXP (x4, 0);
      operands[3] = x6;
      x8 = XEXP (x4, 1);
      operands[1] = x8;
      x7 = XEXP (x3, 1);
      operands[2] = x7;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (pattern186 (x4, 
E_DImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && (
#line 7041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            {
              *pnum_clobbers = 1;
              return 2300; /* *adddi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !(
#line 7075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2304; /* *adddi3_alc_carry2_cconly */

        case E_SImode:
          if (pattern186 (x4, 
E_SImode) != 0)
            return -1;
          x5 = XEXP (x2, 1);
          if (rtx_equal_p (x5, operands[1])
              && 
#line 7041 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            {
              *pnum_clobbers = 1;
              return 2301; /* *addsi3_alc_carry1_cconly */
            }
          if (!rtx_equal_p (x5, operands[2])
              || !
#line 7075 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
            return -1;
          *pnum_clobbers = 1;
          return 2305; /* *addsi3_alc_carry2_cconly */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_30 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[4] = x5;
  x6 = XEXP (x3, 1);
  operands[1] = x6;
  x7 = XEXP (x3, 2);
  operands[2] = x7;
  x8 = XEXP (x4, 0);
  switch (GET_CODE (x8))
    {
    case REG:
    case SUBREG:
      return recog_29 (x1, insn, pnum_clobbers);

    case NOT:
      x9 = XEXP (x8, 0);
      operands[3] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern206 (x3, 
E_V1QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1QImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1453; /* *vec_sel0v1qi */
          if (!all_ones_operand (operands[4], E_V1QImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1491; /* *vec_sel1v1qi */

        case E_V2QImode:
          if (pattern206 (x3, 
E_V2QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2QImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1454; /* *vec_sel0v2qi */
          if (!all_ones_operand (operands[4], E_V2QImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1492; /* *vec_sel1v2qi */

        case E_V4QImode:
          if (pattern206 (x3, 
E_V4QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4QImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1455; /* *vec_sel0v4qi */
          if (!all_ones_operand (operands[4], E_V4QImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1493; /* *vec_sel1v4qi */

        case E_V8QImode:
          if (pattern206 (x3, 
E_V8QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8QImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1456; /* *vec_sel0v8qi */
          if (!all_ones_operand (operands[4], E_V8QImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1494; /* *vec_sel1v8qi */

        case E_V16QImode:
          if (pattern206 (x3, 
E_V16QImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V16QImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1457; /* *vec_sel0v16qi */
          if (!all_ones_operand (operands[4], E_V16QImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1495; /* *vec_sel1v16qi */

        case E_V1HImode:
          if (pattern206 (x3, 
E_V1HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1HImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1458; /* *vec_sel0v1hi */
          if (!all_ones_operand (operands[4], E_V1HImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1496; /* *vec_sel1v1hi */

        case E_V2HImode:
          if (pattern206 (x3, 
E_V2HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2HImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1459; /* *vec_sel0v2hi */
          if (!all_ones_operand (operands[4], E_V2HImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1497; /* *vec_sel1v2hi */

        case E_V4HImode:
          if (pattern206 (x3, 
E_V4HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4HImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1460; /* *vec_sel0v4hi */
          if (!all_ones_operand (operands[4], E_V4HImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1498; /* *vec_sel1v4hi */

        case E_V8HImode:
          if (pattern206 (x3, 
E_V8HImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V8HImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1461; /* *vec_sel0v8hi */
          if (!all_ones_operand (operands[4], E_V8HImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1499; /* *vec_sel1v8hi */

        case E_V1SImode:
          if (pattern206 (x3, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1462; /* *vec_sel0v1si */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1500; /* *vec_sel1v1si */

        case E_V2SImode:
          if (pattern206 (x3, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1463; /* *vec_sel0v2si */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1501; /* *vec_sel1v2si */

        case E_V4SImode:
          if (pattern206 (x3, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1464; /* *vec_sel0v4si */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1502; /* *vec_sel1v4si */

        case E_V1DImode:
          if (pattern206 (x3, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1465; /* *vec_sel0v1di */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1503; /* *vec_sel1v1di */

        case E_V2DImode:
          if (pattern206 (x3, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1466; /* *vec_sel0v2di */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1504; /* *vec_sel1v2di */

        case E_V1SFmode:
          if (pattern207 (x3, 
E_V1SFmode, 
E_V1SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1SImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1467; /* *vec_sel0v1sf */
          if (!all_ones_operand (operands[4], E_V1SImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1505; /* *vec_sel1v1sf */

        case E_V2SFmode:
          if (pattern207 (x3, 
E_V2SFmode, 
E_V2SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2SImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1468; /* *vec_sel0v2sf */
          if (!all_ones_operand (operands[4], E_V2SImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1506; /* *vec_sel1v2sf */

        case E_V4SFmode:
          if (pattern207 (x3, 
E_V4SFmode, 
E_V4SImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V4SImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1469; /* *vec_sel0v4sf */
          if (!all_ones_operand (operands[4], E_V4SImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1507; /* *vec_sel1v4sf */

        case E_V1DFmode:
          if (pattern207 (x3, 
E_V1DFmode, 
E_V1DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V1DImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1470; /* *vec_sel0v1df */
          if (!all_ones_operand (operands[4], E_V1DImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1508; /* *vec_sel1v1df */

        case E_V2DFmode:
          if (pattern207 (x3, 
E_V2DFmode, 
E_V2DImode) != 0)
            return -1;
          if (const0_operand (operands[4], E_V2DImode)
              && 
#line 2709 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1471; /* *vec_sel0v2df */
          if (!all_ones_operand (operands[4], E_V2DImode)
              || !
#line 2733 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1509; /* *vec_sel1v2df */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_42 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 2);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[2] = x3;
  if (const_int_operand (operands[2], E_VOIDmode))
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (XWINT (x3, 0) != 0L)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x1, 1);
  operands[2] = x5;
  switch (GET_MODE (x2))
    {
    case E_DImode:
      if (!register_operand (operands[2], E_DImode)
          || !(
#line 4861 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 783 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2018; /* *insvdi_mem_reg */

    case E_SImode:
      if (!register_operand (operands[2], E_SImode)
          || !(
#line 4861 "../../gcc/config/s390/s390.md"
(EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0) && 
#line 783 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH)))
        return -1;
      return 2019; /* *insvsi_mem_reg */

    default:
      return -1;
    }
}

 int
recog_46 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern64 (x3, 
E_V1QImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 696; /* addv1qi3 */

        case E_V2QImode:
          if (pattern64 (x3, 
E_V2QImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 697; /* addv2qi3 */

        case E_V4QImode:
          if (pattern64 (x3, 
E_V4QImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 698; /* addv4qi3 */

        case E_V8QImode:
          if (pattern64 (x3, 
E_V8QImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 699; /* addv8qi3 */

        case E_V16QImode:
          if (pattern64 (x3, 
E_V16QImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 700; /* addv16qi3 */

        case E_V1HImode:
          if (pattern64 (x3, 
E_V1HImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 701; /* addv1hi3 */

        case E_V2HImode:
          if (pattern64 (x3, 
E_V2HImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 702; /* addv2hi3 */

        case E_V4HImode:
          if (pattern64 (x3, 
E_V4HImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 703; /* addv4hi3 */

        case E_V8HImode:
          if (pattern64 (x3, 
E_V8HImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 704; /* addv8hi3 */

        case E_V1SImode:
          if (pattern64 (x3, 
E_V1SImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 705; /* addv1si3 */

        case E_V2SImode:
          if (pattern64 (x3, 
E_V2SImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 706; /* addv2si3 */

        case E_V4SImode:
          if (pattern64 (x3, 
E_V4SImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 707; /* addv4si3 */

        case E_V1DImode:
          if (pattern64 (x3, 
E_V1DImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 708; /* addv1di3 */

        case E_V2DImode:
          if (pattern64 (x3, 
E_V2DImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 709; /* addv2di3 */

        case E_V1TImode:
          if (pattern64 (x3, 
E_V1TImode) != 0
              || !
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 710; /* addv1ti3 */

        case E_TImode:
          if (GET_MODE (x3) != E_TImode
              || !nonimmediate_operand (operands[1], E_TImode)
              || !general_operand (operands[2], E_TImode))
            return -1;
          if (nonimmediate_operand (operands[0], E_TImode)
              && 
#line 1249 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 711; /* *addti3 */
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_TImode)
              || !
#line 6072 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return -1;
          *pnum_clobbers = 1;
          return 2208; /* *addti3 */

        case E_V4SFmode:
          if (pattern0 (x3, 
E_V4SFmode) != 0
              || !(
#line 1974 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1239; /* addv4sf3 */

        case E_V2DFmode:
          if (pattern0 (x3, 
E_V2DFmode) != 0
              || !
#line 1974 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1240; /* addv2df3 */

        case E_V1TFmode:
          if (pattern0 (x3, 
E_V1TFmode) != 0
              || !(
#line 1974 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 89 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1241; /* addv1tf3 */

        case E_TFmode:
          if (!register_operand (operands[0], E_TFmode)
              || GET_MODE (x3) != E_TFmode)
            return -1;
          if (register_operand (operands[1], E_TFmode)
              && register_operand (operands[2], E_TFmode)
              && (
#line 1974 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 90 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return 1242; /* addtf3_vr */
          if (pnum_clobbers == NULL
              || !nonimmediate_operand (operands[1], E_TFmode)
              || !general_operand (operands[2], E_TFmode)
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(!TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2238; /* addtf3_fpr */

        case E_FPRX2mode:
          if (pnum_clobbers == NULL
              || pattern175 (x3, 
E_FPRX2mode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 751 "../../gcc/config/s390/s390.md"
(TARGET_VXE)))
            return -1;
          *pnum_clobbers = 1;
          return 2239; /* addfprx23 */

        case E_DFmode:
          if (pnum_clobbers == NULL
              || pattern175 (x3, 
E_DFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2240; /* adddf3 */

        case E_SFmode:
          if (pnum_clobbers == NULL
              || pattern175 (x3, 
E_SFmode) != 0
              || !
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          *pnum_clobbers = 1;
          return 2241; /* addsf3 */

        case E_TDmode:
          if (pnum_clobbers == NULL
              || pattern175 (x3, 
E_TDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2242; /* addtd3 */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || pattern175 (x3, 
E_DDmode) != 0
              || !(
#line 6490 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT) && 
#line 752 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP)))
            return -1;
          *pnum_clobbers = 1;
          return 2243; /* adddd3 */

        default:
          return -1;
        }

    case ASHIFT:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != SIGN_EXTEND
          || GET_MODE (x6) != E_DImode)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x5 = XEXP (x3, 1);
      if (!register_operand (x5, E_DImode))
        return -1;
      x8 = XEXP (x6, 0);
      switch (GET_CODE (x8))
        {
        case REG:
        case SUBREG:
          operands[1] = x8;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          operands[2] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1838; /* *lxah_index_base */

            case 2L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1839; /* *lxaf_index_base */

            case 3L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1840; /* *lxag_index_base */

            case 4L:
              if (!
#line 2086 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                return -1;
              return 1841; /* *lxaq_index_base */

            default:
              return -1;
            }

        case PLUS:
          if (GET_MODE (x8) != E_SImode)
            return -1;
          x9 = XEXP (x8, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_SImode))
            return -1;
          x10 = XEXP (x8, 1);
          operands[2] = x10;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          operands[3] = x5;
          switch (XWINT (x7, 0))
            {
            case 1L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1842; /* *lxah_displacement_index_base */

            case 2L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1843; /* *lxaf_displacement_index_base */

            case 3L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1844; /* *lxag_displacement_index_base */

            case 4L:
              if (!
#line 2097 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
                return -1;
              return 1845; /* *lxaq_displacement_index_base */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (pattern112 (x3) != 0
          || !
#line 2106 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1846; /* *lxab_displacement_index_base */

    case AND:
      if (GET_MODE (x4) != E_DImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_DImode)
        return -1;
      x11 = XEXP (x6, 1);
      if (GET_CODE (x11) != CONST_INT)
        return -1;
      x7 = XEXP (x4, 1);
      if (GET_CODE (x7) != CONST_INT
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x8 = XEXP (x6, 0);
      operands[1] = x8;
      if (register_operand (operands[1], E_DImode))
        {
          x5 = XEXP (x3, 1);
          operands[2] = x5;
          if (register_operand (operands[2], E_DImode))
            {
              switch (pattern269 (x4))
                {
                case 0:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1851; /* *llxah_index_base */
                  break;

                case 1:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1852; /* *llxaf_index_base */
                  break;

                case 2:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1853; /* *llxag_index_base */
                  break;

                case 3:
                  if (
#line 2134 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT))
                    return 1854; /* *llxaq_index_base */
                  break;

                default:
                  break;
                }
            }
        }
      if (GET_CODE (x8) != SUBREG
          || maybe_ne (SUBREG_BYTE (x8), 0)
          || GET_MODE (x8) != E_DImode)
        return -1;
      x9 = XEXP (x8, 0);
      if (GET_CODE (x9) != PLUS
          || GET_MODE (x9) != E_SImode)
        return -1;
      x12 = XEXP (x9, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x13 = XEXP (x9, 1);
      operands[2] = x13;
      if (!const_int_operand (operands[2], E_SImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!register_operand (operands[3], E_DImode))
        return -1;
      switch (pattern269 (x4))
        {
        case 0:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1855; /* *llxah_displacement_index_base */

        case 1:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1856; /* *llxaf_displacement_index_base */

        case 2:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1857; /* *llxag_displacement_index_base */

        case 3:
          if (!
#line 2147 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
            return -1;
          return 1858; /* *llxaq_displacement_index_base */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      if (pattern112 (x3) != 0
          || !
#line 2156 "../../gcc/config/s390/s390.md"
(TARGET_Z17 && TARGET_64BIT && INTVAL (operands[2]) >= -0x80000 && INTVAL (operands[2]) <= 0x7FFFF))
        return -1;
      return 1859; /* *llxab_displacement_index_base */

    default:
      return -1;
    }
}

 int
recog_62 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      if (!register_operand (operands[0], E_V1QImode)
          || GET_MODE (x3) != E_V1QImode
          || !register_operand (operands[1], E_V1QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
        return 1002; /* *ashrv1qi3 */
      if (!register_operand (operands[2], E_V1QImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1071; /* vashrv1qi3 */

    case E_V2QImode:
      if (!register_operand (operands[0], E_V2QImode)
          || GET_MODE (x3) != E_V2QImode
          || !register_operand (operands[1], E_V2QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
        return 1006; /* *ashrv2qi3 */
      if (!register_operand (operands[2], E_V2QImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1072; /* vashrv2qi3 */

    case E_V4QImode:
      if (!register_operand (operands[0], E_V4QImode)
          || GET_MODE (x3) != E_V4QImode
          || !register_operand (operands[1], E_V4QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
        return 1010; /* *ashrv4qi3 */
      if (!register_operand (operands[2], E_V4QImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1073; /* vashrv4qi3 */

    case E_V8QImode:
      if (!register_operand (operands[0], E_V8QImode)
          || GET_MODE (x3) != E_V8QImode
          || !register_operand (operands[1], E_V8QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
        return 1014; /* *ashrv8qi3 */
      if (!register_operand (operands[2], E_V8QImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1074; /* vashrv8qi3 */

    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x3) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
        return 1018; /* *ashrv16qi3 */
      if (!register_operand (operands[2], E_V16QImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1075; /* vashrv16qi3 */

    case E_V1HImode:
      if (!register_operand (operands[0], E_V1HImode)
          || GET_MODE (x3) != E_V1HImode
          || !register_operand (operands[1], E_V1HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
        return 1022; /* *ashrv1hi3 */
      if (!register_operand (operands[2], E_V1HImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1076; /* vashrv1hi3 */

    case E_V2HImode:
      if (!register_operand (operands[0], E_V2HImode)
          || GET_MODE (x3) != E_V2HImode
          || !register_operand (operands[1], E_V2HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
        return 1026; /* *ashrv2hi3 */
      if (!register_operand (operands[2], E_V2HImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1077; /* vashrv2hi3 */

    case E_V4HImode:
      if (!register_operand (operands[0], E_V4HImode)
          || GET_MODE (x3) != E_V4HImode
          || !register_operand (operands[1], E_V4HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
        return 1030; /* *ashrv4hi3 */
      if (!register_operand (operands[2], E_V4HImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1078; /* vashrv4hi3 */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x3) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
        return 1034; /* *ashrv8hi3 */
      if (!register_operand (operands[2], E_V8HImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1079; /* vashrv8hi3 */

    case E_V1SImode:
      if (!register_operand (operands[0], E_V1SImode)
          || GET_MODE (x3) != E_V1SImode
          || !register_operand (operands[1], E_V1SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
        return 1038; /* *ashrv1si3 */
      if (!register_operand (operands[2], E_V1SImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1080; /* vashrv1si3 */

    case E_V2SImode:
      if (!register_operand (operands[0], E_V2SImode)
          || GET_MODE (x3) != E_V2SImode
          || !register_operand (operands[1], E_V2SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
        return 1042; /* *ashrv2si3 */
      if (!register_operand (operands[2], E_V2SImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1081; /* vashrv2si3 */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x3) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
        return 1046; /* *ashrv4si3 */
      if (!register_operand (operands[2], E_V4SImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1082; /* vashrv4si3 */

    case E_V1DImode:
      if (!register_operand (operands[0], E_V1DImode)
          || GET_MODE (x3) != E_V1DImode
          || !register_operand (operands[1], E_V1DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
        return 1050; /* *ashrv1di3 */
      if (!register_operand (operands[2], E_V1DImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1083; /* vashrv1di3 */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x3) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode))
        return -1;
      if (shift_count_operand_vec (operands[2], E_QImode)
          && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
        return 1054; /* *ashrv2di3 */
      if (!register_operand (operands[2], E_V2DImode)
          || !
#line 1678 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1084; /* vashrv2di3 */

    case E_DImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_DImode) != 0)
        return -1;
      if (
#line 9734 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
        {
          *pnum_clobbers = 1;
          return 2528; /* *ashrdi3_31 */
        }
      if (!
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2531; /* *ashrdi3 */

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern10 (x3, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2534; /* *ashrsi3 */

    default:
      return -1;
    }
}

 int
recog_66 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_CODE (x2))
    {
    case REG:
    case SUBREG:
      operands[0] = x2;
      x3 = XEXP (x1, 1);
      switch (pattern11 (x3))
        {
        case 0:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1QImode)) - 1)
  ))
            return 1003; /* *lshrv1qi3 */
          if (register_operand (operands[2], E_V1QImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1085; /* vlshrv1qi3 */
          break;

        case 1:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2QImode)) - 1)
  ))
            return 1007; /* *lshrv2qi3 */
          if (register_operand (operands[2], E_V2QImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1086; /* vlshrv2qi3 */
          break;

        case 2:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4QImode)) - 1)
  ))
            return 1011; /* *lshrv4qi3 */
          if (register_operand (operands[2], E_V4QImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1087; /* vlshrv4qi3 */
          break;

        case 3:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8QImode)) - 1)
  ))
            return 1015; /* *lshrv8qi3 */
          if (register_operand (operands[2], E_V8QImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1088; /* vlshrv8qi3 */
          break;

        case 4:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V16QImode)) - 1)
  ))
            return 1019; /* *lshrv16qi3 */
          if (register_operand (operands[2], E_V16QImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1089; /* vlshrv16qi3 */
          break;

        case 5:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1HImode)) - 1)
  ))
            return 1023; /* *lshrv1hi3 */
          if (register_operand (operands[2], E_V1HImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1090; /* vlshrv1hi3 */
          break;

        case 6:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2HImode)) - 1)
  ))
            return 1027; /* *lshrv2hi3 */
          if (register_operand (operands[2], E_V2HImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1091; /* vlshrv2hi3 */
          break;

        case 7:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4HImode)) - 1)
  ))
            return 1031; /* *lshrv4hi3 */
          if (register_operand (operands[2], E_V4HImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1092; /* vlshrv4hi3 */
          break;

        case 8:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V8HImode)) - 1)
  ))
            return 1035; /* *lshrv8hi3 */
          if (register_operand (operands[2], E_V8HImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1093; /* vlshrv8hi3 */
          break;

        case 9:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1SImode)) - 1)
  ))
            return 1039; /* *lshrv1si3 */
          if (register_operand (operands[2], E_V1SImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1094; /* vlshrv1si3 */
          break;

        case 10:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2SImode)) - 1)
  ))
            return 1043; /* *lshrv2si3 */
          if (register_operand (operands[2], E_V2SImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1095; /* vlshrv2si3 */
          break;

        case 11:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V4SImode)) - 1)
  ))
            return 1047; /* *lshrv4si3 */
          if (register_operand (operands[2], E_V4SImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1096; /* vlshrv4si3 */
          break;

        case 12:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V1DImode)) - 1)
  ))
            return 1051; /* *lshrv1di3 */
          if (register_operand (operands[2], E_V1DImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1097; /* vlshrv1di3 */
          break;

        case 13:
          if (shift_count_operand_vec (operands[2], E_QImode)
              && 
#line 1637 "../../gcc/config/s390/vector.md"
(TARGET_VX
  && s390_valid_shift_count (operands[2],
    GET_MODE_BITSIZE (GET_MODE_INNER (V2DImode)) - 1)
  ))
            return 1055; /* *lshrv2di3 */
          if (register_operand (operands[2], E_V2DImode)
              && 
#line 1687 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1098; /* vlshrv2di3 */
          break;

        case 14:
          if (
#line 9693 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return 2523; /* *lshrdi3_31 */
          if (
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
            return 2525; /* *lshrdi3 */
          break;

        case 15:
          return 2527; /* *lshrsi3 */

        default:
          break;
        }
      break;

    case ZERO_EXTRACT:
      res = recog_28 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 32]
      || GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_DImode)
    return -1;
  x5 = XEXP (x2, 2);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!memory_operand (operands[0], E_QImode))
    return -1;
  x7 = XEXP (x2, 1);
  operands[1] = x7;
  if (!const_int_operand (operands[1], E_VOIDmode))
    return -1;
  x8 = XEXP (x3, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_DImode)
      || !
#line 4882 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), 0, 64)
   && INTVAL (operands[1]) > 0
   && INTVAL (operands[1]) <= GET_MODE_BITSIZE (SImode)
   && INTVAL (operands[1]) % BITS_PER_UNIT == 0))
    return -1;
  return 2020; /* *insvdi_mem_reghigh */
}

 int
recog_78 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      switch (GET_CODE (x3))
        {
        case NE:
        case EQ:
        case GE:
        case GT:
        case LE:
        case LT:
          res = recog_31 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      if (pnum_clobbers != NULL)
        {
          res = recog_32 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (!s390_comparison (x3, E_VOIDmode))
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG)
        return -1;
      operands[2] = x4;
      if (cc_reg_operand (operands[2], E_VOIDmode))
        {
          res = recog_33 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      if (REGNO (x4) != 33)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != CONST_INT)
        return -1;
      operands[2] = x5;
      if (const_int_operand (operands[2], E_VOIDmode))
        {
          x6 = XEXP (x1, 0);
          if (GET_CODE (x6) == PC)
            {
              operands[1] = x3;
              x7 = XEXP (x2, 1);
              switch (GET_CODE (x7))
                {
                case LABEL_REF:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == PC)
                    {
                      x9 = XEXP (x7, 0);
                      operands[0] = x9;
                      return 2537; /* *cjump_64 */
                    }
                  break;

                case PC:
                  x8 = XEXP (x2, 2);
                  if (GET_CODE (x8) == LABEL_REF)
                    {
                      x10 = XEXP (x8, 0);
                      operands[0] = x10;
                      return 2541; /* *icjump_64 */
                    }
                  break;

                default:
                  break;
                }
            }
        }
      if (XWINT (x5, 0) != 0L)
        return -1;
      x6 = XEXP (x1, 0);
      if (GET_CODE (x6) != PC)
        return -1;
      x7 = XEXP (x2, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case PLUS:
        case MINUS:
        case MULT:
        case AND:
        case SIGN_EXTEND:
        case ZERO_EXTEND:
        case HIGH:
          operands[0] = x7;
          if (!address_operand (operands[0], E_VOIDmode))
            return -1;
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[1] = x3;
          if (!
#line 9825 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2538; /* *cjump_long */

        case RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9848 "../../gcc/config/s390/s390.md"
(s390_can_use_return_insn ()))
            return -1;
          return 2539; /* *creturn */

        case SIMPLE_RETURN:
          x8 = XEXP (x2, 2);
          if (GET_CODE (x8) != PC)
            return -1;
          operands[0] = x3;
          if (!
#line 9848 "../../gcc/config/s390/s390.md"
(s390_can_use_simple_return_insn ()))
            return -1;
          return 2540; /* *csimple_return */

        case PC:
          operands[1] = x3;
          x8 = XEXP (x2, 2);
          operands[0] = x8;
          if (!address_operand (operands[0], E_VOIDmode)
              || !
#line 9902 "../../gcc/config/s390/s390.md"
(!TARGET_INDIRECT_BRANCH_NOBP_JUMP))
            return -1;
          return 2542; /* *icjump_long */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XVECEXP (x1, 0, 1);
  switch (GET_CODE (x5))
    {
    case UNSPEC:
      if (XVECLEN (x5, 0) != 1
          || XINT (x5, 1) != 0)
        return -1;
      x6 = XVECEXP (x5, 0, 0);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !register_operand (operands[1], E_TFmode)
              || GET_MODE (x5) != E_DFmode
              || !const_int_operand (operands[2], E_VOIDmode)
              || !
#line 3243 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 1575; /* *trunctfdf2_vr */

        case E_DDmode:
          if (pnum_clobbers == NULL
              || !register_operand (operands[0], E_DDmode)
              || GET_MODE (x3) != E_DDmode
              || !register_operand (operands[1], E_TDmode)
              || GET_MODE (x5) != E_DImode
              || !const_mask_operand (operands[2], E_DImode)
              || !
#line 5742 "../../gcc/config/s390/s390.md"
(TARGET_HARD_DFP))
            return -1;
          *pnum_clobbers = 1;
          return 2111; /* *trunctddd2 */

        default:
          return -1;
        }

    case CLOBBER:
      if (!register_operand (operands[1], E_TFmode))
        return -1;
      x7 = XEXP (x5, 0);
      operands[2] = x7;
      if (!scratch_operand (operands[2], E_TFmode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_DFmode:
          if (!register_operand (operands[0], E_DFmode)
              || GET_MODE (x3) != E_DFmode
              || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2109; /* trunctfdf2_fpr */

        case E_SFmode:
          if (!register_operand (operands[0], E_SFmode)
              || GET_MODE (x3) != E_SFmode
              || !
#line 5719 "../../gcc/config/s390/s390.md"
(TARGET_HARD_FLOAT))
            return -1;
          return 2110; /* trunctfsf2_fpr */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_97 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case STRICT_LOW_PART:
      if (pattern90 (x1) != 0
          || !subreg_register_operand (operands[0], E_HImode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_HImode))
        return -1;
      return 1874; /* movstricthi */

    case SUBREG:
    case MEM:
      operands[0] = x3;
      if (!memory_operand (operands[0], E_BLKmode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != USE)
        return -1;
      x4 = XEXP (x2, 1);
      operands[1] = x4;
      if (!memory_operand (operands[1], E_BLKmode))
        return -1;
      x6 = XEXP (x5, 0);
      operands[2] = x6;
      if (!const_int_operand (operands[2], E_VOIDmode)
          || !
#line 3113 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        return -1;
      return 1891; /* *mvc */

    case ZERO_EXTRACT:
      if (pattern90 (x1) != 0)
        return -1;
      x7 = XEXP (x3, 1);
      operands[1] = x7;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      x8 = XEXP (x3, 2);
      operands[2] = x8;
      if (!const_int_operand (operands[2], E_VOIDmode))
        return -1;
      x4 = XEXP (x2, 1);
      operands[3] = x4;
      switch (GET_MODE (x3))
        {
        case E_DImode:
          if (!nonimmediate_operand (operands[0], E_DImode)
              || !nonimmediate_operand (operands[3], E_DImode)
              || !(
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (DImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1969; /* *insvdi_clobbercc */

        case E_SImode:
          if (!nonimmediate_operand (operands[0], E_SImode)
              || !nonimmediate_operand (operands[3], E_SImode)
              || !
#line 4486 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]),
			     GET_MODE_BITSIZE (SImode))
   && (INTVAL (operands[1]) + INTVAL (operands[2])) <= 32))
            return -1;
          return 1971; /* *insvsi_clobbercc */

        default:
          return -1;
        }

    case PC:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 1)
        return -1;
      x4 = XEXP (x2, 1);
      operands[0] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (!register_operand (operands[0], E_DImode)
              || GET_MODE (x6) != E_DImode
              || !(
#line 10419 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
            return -1;
          return 2562; /* indirect_jump_via_thunkdi */

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x6) != E_SImode
              || !(
#line 10419 "../../gcc/config/s390/s390.md"
(TARGET_INDIRECT_BRANCH_NOBP_JUMP_THUNK
  && !TARGET_CPU_Z10) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
            return -1;
          return 2563; /* indirect_jump_via_thunksi */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_101 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return -1;
  switch (pattern192 (x6))
    {
    case 0:
      if (!(
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (DImode))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 1939; /* *extzvdi_clobbercc */

    case 1:
      if (!
#line 4320 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[2]), INTVAL (operands[3]),
			     GET_MODE_BITSIZE (SImode))))
        return -1;
      return 1941; /* *extzvsi_clobbercc */

    default:
      return -1;
    }
}

 int
recog_104 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x9 = XEXP (x6, 2);
              operands[5] = x9;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern277 (x4, 
E_DImode) != 0
                      || !
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1945; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern277 (x4, 
E_SImode) != 0
                      || !
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  return 1947; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern262 (x4, 
E_DImode) != 0
                      || !(
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1973; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern262 (x4, 
E_SImode) != 0
                      || !
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  return 1975; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern263 (x4, 
E_DImode) != 0
                      || !(
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1979; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern263 (x4, 
E_SImode) != 0
                      || !
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  return 1981; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern264 (x4, 
E_DImode) != 0
                      || !(
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1983; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern264 (x4, 
E_SImode) != 0
                      || !
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  return 1985; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  x7 = XEXP (x6, 0);
                  if (GET_CODE (x7) == LSHIFTRT
                      && GET_MODE (x7) == E_DImode
                      && pattern227 (x4, 
E_SImode) == 0
                      && const_int_operand (operands[2], E_SImode))
                    {
                      x10 = XEXP (x7, 0);
                      operands[3] = x10;
                      if (register_operand (operands[3], E_DImode))
                        {
                          x11 = XEXP (x7, 1);
                          operands[4] = x11;
                          if (nonzero_shift_count_operand (operands[4], E_DImode)
                              && 
#line 4588 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == ~(HOST_WIDE_INT_M1U >> UINTVAL (operands[4]))))
                            return 1987; /* *risbg_sidi_ior_and_lshiftrt */
                        }
                    }
                }
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern249 (x4, 
E_DImode) != 0
                      || !(
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  return 1992; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern249 (x4, 
E_SImode) != 0
                      || !
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  return 1994; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case 1:
          if (!
#line 4700 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1996; /* *rosbg_di_rotl */

        case 2:
          if (!(
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1998; /* *rosbg_di_srl_bitmask */

        case 3:
          if (!
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 2000; /* *rosbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2002; /* *rosbg_di_sll_bitmask */

        case 5:
          if (!
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 2004; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      switch (GET_CODE (x13))
        {
        case REG:
        case SUBREG:
        case MEM:
          switch (pattern95 (x4))
            {
            case 0:
              if (!(
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2006; /* *rosbg_di_sll */

            case 1:
              if (!
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 2008; /* *rosbg_si_sll */

            default:
              return -1;
            }

        case ZERO_EXTEND:
          if (GET_MODE (x13) != E_TImode)
            return -1;
          x14 = XEXP (x13, 0);
          if (GET_CODE (x14) != CLZ
              || GET_MODE (x14) != E_DImode)
            return -1;
          x15 = XEXP (x5, 1);
          if (x15 != const_int_rtx[MAX_SAVED_CONST_INT + 64])
            return -1;
          x6 = XEXP (x4, 1);
          if (GET_CODE (x6) != ZERO_EXTEND
              || GET_MODE (x6) != E_TImode)
            return -1;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != XOR
              || GET_MODE (x7) != E_DImode)
            return -1;
          x11 = XEXP (x7, 1);
          if (GET_CODE (x11) != LSHIFTRT)
            return -1;
          x16 = XEXP (x11, 1);
          if (GET_CODE (x16) != SUBREG
              || maybe_ne (SUBREG_BYTE (x16), 4)
              || GET_MODE (x16) != E_SImode)
            return -1;
          x17 = XEXP (x16, 0);
          if (GET_CODE (x17) != CLZ
              || GET_MODE (x17) != E_DImode
              || !register_operand (operands[0], E_TImode)
              || GET_MODE (x4) != E_TImode
              || GET_MODE (x5) != E_TImode)
            return -1;
          x18 = XEXP (x14, 0);
          operands[1] = x18;
          if (!register_operand (operands[1], E_DImode))
            return -1;
          x19 = XEXP (x11, 0);
          operands[2] = x19;
          if (!const_int_operand (operands[2], E_DImode))
            return -1;
          x10 = XEXP (x7, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          x20 = XEXP (x17, 0);
          if (!rtx_equal_p (x20, operands[1])
              || !
#line 9627 "../../gcc/config/s390/s390.md"
(UINTVAL (operands[2]) == HOST_WIDE_INT_1U << 63
   && TARGET_EXTIMM && TARGET_ZARCH))
            return -1;
          return 2518; /* clztidi2 */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2010; /* *rosbg_di_srl */

        case 1:
          if (!
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2012; /* *rosbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4792 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 2014; /* *rosbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8675 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2417; /* *oc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8370 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2382; /* *iordi3 */

        case 1:
          if (
#line 8451 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2385; /* *iorsi3_zarch */
          if (!
#line 8479 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2386; /* *iorsi3_esa */

        case 2:
          if (
#line 8507 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2387; /* *iorhi3_zarch */
          if (!
#line 8523 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2388; /* *iorhi3_esa */

        case 3:
          if (
#line 8550 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2389; /* *iorqi3_zarch */
          if (!
#line 8568 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2390; /* *iorqi3_esa */

        default:
          return -1;
        }

    case NOT:
      x12 = XVECEXP (x1, 0, 1);
      if (pattern89 (x12) != 0)
        return -1;
      x13 = XEXP (x5, 0);
      operands[1] = x13;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
        case SUBREG:
          operands[2] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern240 (x4, 
E_DImode) != 0
                  || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2400; /* *orcdi */

            case E_SImode:
              if (pattern240 (x4, 
E_SImode) != 0
                  || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2402; /* *orcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern215 (x4))
            {
            case 0:
              if (!(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2412; /* *nanddi */

            case 1:
              if (!
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2414; /* *nandsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_119 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern44 (x2, 
10, 
1, 
UNSPEC_VOLATILE) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  x5 = XEXP (x3, 1);
  operands[1] = x5;
  x6 = XEXP (x2, 0);
  if (!rtx_equal_p (x6, operands[1]))
    return -1;
  x7 = XEXP (x2, 1);
  x8 = XVECEXP (x7, 0, 0);
  switch (GET_CODE (x8))
    {
    case AND:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2613; /* atomic_fetch_anddi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2617; /* atomic_fetch_andsi_iaf */

        default:
          return -1;
        }

    case IOR:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2614; /* atomic_fetch_ordi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2618; /* atomic_fetch_orsi_iaf */

        default:
          return -1;
        }

    case XOR:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2615; /* atomic_fetch_xordi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2619; /* atomic_fetch_xorsi_iaf */

        default:
          return -1;
        }

    case PLUS:
      switch (pattern217 (x7))
        {
        case 0:
          if (!(
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2616; /* atomic_fetch_adddi_iaf */

        case 1:
          if (!
#line 11431 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
            return -1;
          *pnum_clobbers = 1;
          return 2620; /* atomic_fetch_addsi_iaf */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_3 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[1] = x4;
  x5 = XEXP (x3, 2);
  operands[2] = x5;
  x6 = XEXP (x3, 0);
  switch (GET_CODE (x6))
    {
    case EQ:
      switch (pattern101 (x3))
        {
        case 0:
          if (const0_operand (operands[1], E_V1QImode)
              && all_ones_operand (operands[2], E_V1QImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_60 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1QImode)
              || !const0_operand (operands[2], E_V1QImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_79 (insn, operands);

        case 1:
          if (const0_operand (operands[1], E_V2QImode)
              && all_ones_operand (operands[2], E_V2QImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_61 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2QImode)
              || !const0_operand (operands[2], E_V2QImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_80 (insn, operands);

        case 2:
          if (const0_operand (operands[1], E_V4QImode)
              && all_ones_operand (operands[2], E_V4QImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_62 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4QImode)
              || !const0_operand (operands[2], E_V4QImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_81 (insn, operands);

        case 3:
          if (const0_operand (operands[1], E_V8QImode)
              && all_ones_operand (operands[2], E_V8QImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_63 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8QImode)
              || !const0_operand (operands[2], E_V8QImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_82 (insn, operands);

        case 4:
          if (const0_operand (operands[1], E_V16QImode)
              && all_ones_operand (operands[2], E_V16QImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_64 (insn, operands);
          if (!all_ones_operand (operands[1], E_V16QImode)
              || !const0_operand (operands[2], E_V16QImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_83 (insn, operands);

        case 5:
          if (const0_operand (operands[1], E_V1HImode)
              && all_ones_operand (operands[2], E_V1HImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_65 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1HImode)
              || !const0_operand (operands[2], E_V1HImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_84 (insn, operands);

        case 6:
          if (const0_operand (operands[1], E_V2HImode)
              && all_ones_operand (operands[2], E_V2HImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_66 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2HImode)
              || !const0_operand (operands[2], E_V2HImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_85 (insn, operands);

        case 7:
          if (const0_operand (operands[1], E_V4HImode)
              && all_ones_operand (operands[2], E_V4HImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_67 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4HImode)
              || !const0_operand (operands[2], E_V4HImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_86 (insn, operands);

        case 8:
          if (const0_operand (operands[1], E_V8HImode)
              && all_ones_operand (operands[2], E_V8HImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_68 (insn, operands);
          if (!all_ones_operand (operands[1], E_V8HImode)
              || !const0_operand (operands[2], E_V8HImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_87 (insn, operands);

        case 9:
          if (const0_operand (operands[1], E_V1SImode)
              && all_ones_operand (operands[2], E_V1SImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_69 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SImode)
              || !const0_operand (operands[2], E_V1SImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_88 (insn, operands);

        case 10:
          if (const0_operand (operands[1], E_V2SImode)
              && all_ones_operand (operands[2], E_V2SImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_70 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SImode)
              || !const0_operand (operands[2], E_V2SImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_89 (insn, operands);

        case 11:
          if (const0_operand (operands[1], E_V4SImode)
              && all_ones_operand (operands[2], E_V4SImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_71 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SImode)
              || !const0_operand (operands[2], E_V4SImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_90 (insn, operands);

        case 12:
          if (const0_operand (operands[1], E_V1DImode)
              && all_ones_operand (operands[2], E_V1DImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_72 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DImode)
              || !const0_operand (operands[2], E_V1DImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_91 (insn, operands);

        case 13:
          if (const0_operand (operands[1], E_V2DImode)
              && all_ones_operand (operands[2], E_V2DImode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_73 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DImode)
              || !const0_operand (operands[2], E_V2DImode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_92 (insn, operands);

        case 14:
          if (const0_operand (operands[1], E_V1SFmode)
              && all_ones_operand (operands[2], E_V1SFmode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_74 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1SFmode)
              || !const0_operand (operands[2], E_V1SFmode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_93 (insn, operands);

        case 15:
          if (const0_operand (operands[1], E_V2SFmode)
              && all_ones_operand (operands[2], E_V2SFmode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_75 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2SFmode)
              || !const0_operand (operands[2], E_V2SFmode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_94 (insn, operands);

        case 16:
          if (const0_operand (operands[1], E_V4SFmode)
              && all_ones_operand (operands[2], E_V4SFmode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_76 (insn, operands);
          if (!all_ones_operand (operands[1], E_V4SFmode)
              || !const0_operand (operands[2], E_V4SFmode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_95 (insn, operands);

        case 17:
          if (const0_operand (operands[1], E_V1DFmode)
              && all_ones_operand (operands[2], E_V1DFmode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_77 (insn, operands);
          if (!all_ones_operand (operands[1], E_V1DFmode)
              || !const0_operand (operands[2], E_V1DFmode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_96 (insn, operands);

        case 18:
          if (const0_operand (operands[1], E_V2DFmode)
              && all_ones_operand (operands[2], E_V2DFmode)
              && 
#line 2641 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return gen_split_78 (insn, operands);
          if (!all_ones_operand (operands[1], E_V2DFmode)
              || !const0_operand (operands[2], E_V2DFmode)
              || !
#line 2655 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return NULL;
          return gen_split_97 (insn, operands);

        default:
          return NULL;
        }

    case NE:
      return split_2 (x1, insn);

    default:
      return NULL;
    }
}

 rtx_insn *
split_insns (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24;
  rtx_insn *res ATTRIBUTE_UNUSED;
  recog_data.insn = NULL;
  switch (GET_CODE (x1))
    {
    case SET:
      return split_7 (x1, insn);

    case PARALLEL:
      switch (XVECLEN (x1, 0))
        {
        case 2:
          return split_6 (x1, insn);

        case 3:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case VEC_SELECT:
              if (GET_MODE (x4) != E_V8HImode)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != PARALLEL
                  || XVECLEN (x5, 0) != 8)
                return NULL;
              x6 = XVECEXP (x5, 0, 0);
              if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
                return NULL;
              x7 = XVECEXP (x5, 0, 1);
              if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 6])
                return NULL;
              x8 = XVECEXP (x5, 0, 2);
              if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 5])
                return NULL;
              x9 = XVECEXP (x5, 0, 3);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 4])
                return NULL;
              x10 = XVECEXP (x5, 0, 4);
              if (x10 != const_int_rtx[MAX_SAVED_CONST_INT + 3])
                return NULL;
              x11 = XVECEXP (x5, 0, 5);
              if (x11 != const_int_rtx[MAX_SAVED_CONST_INT + 2])
                return NULL;
              x12 = XVECEXP (x5, 0, 6);
              if (x12 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
                return NULL;
              x13 = XVECEXP (x5, 0, 7);
              if (x13 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != CLOBBER
                  || pattern265 (x1) != 0
                  || !(
#line 1159 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 1164 "../../gcc/config/s390/vector.md"
( reload_completed && REG_P (operands[0]) && REG_P (operands[1]))))
                return NULL;
              return gen_split_49 (insn, operands);

            case IF_THEN_ELSE:
              x15 = XEXP (x4, 0);
              if (!s390_brx_operator (x15, E_VOIDmode))
                return NULL;
              operands[6] = x15;
              x16 = XEXP (x15, 0);
              if (GET_CODE (x16) != PLUS)
                return NULL;
              x5 = XEXP (x4, 1);
              if (GET_CODE (x5) != LABEL_REF)
                return NULL;
              x17 = XEXP (x4, 2);
              if (GET_CODE (x17) != PC)
                return NULL;
              x18 = XEXP (x2, 0);
              if (GET_CODE (x18) != PC)
                return NULL;
              x14 = XVECEXP (x1, 0, 1);
              if (GET_CODE (x14) != SET)
                return NULL;
              x19 = XEXP (x14, 1);
              if (GET_CODE (x19) != PLUS)
                return NULL;
              switch (pattern229 (x1))
                {
                case 0:
                  if (!(
#line 10033 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return NULL;
                  return gen_split_389 (insn, operands);

                case 1:
                  if (!
#line 10033 "../../gcc/config/s390/s390.md"
(!reload_completed && !reload_in_progress))
                    return NULL;
                  return gen_split_390 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 4:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x20 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x20) != CLOBBER)
            return NULL;
          x4 = XEXP (x2, 1);
          switch (GET_CODE (x4))
            {
            case SUBREG:
            case MEM:
              if (pattern74 (x1) != 0)
                return NULL;
              switch (pattern195 (x1))
                {
                case 0:
                  if (!
#line 3605 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_325 (insn, operands);

                case 1:
                  if (!
#line 3617 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_326 (insn, operands);

                case 2:
                  if (scratch_operand (operands[3], E_VOIDmode)
                      && 
#line 3631 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return gen_split_327 (insn, operands);
                  if (!register_operand (operands[3], E_VOIDmode)
                      || !
#line 3645 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_328 (insn, operands);

                default:
                  return NULL;
                }

            case COMPARE:
              if (pattern73 (x1) != 0)
                return NULL;
              switch (pattern195 (x1))
                {
                case 0:
                  if (!
#line 4055 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_334 (insn, operands);

                case 1:
                  if (!
#line 4068 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_335 (insn, operands);

                case 2:
                  if (scratch_operand (operands[3], E_VOIDmode)
                      && 
#line 4083 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return gen_split_336 (insn, operands);
                  if (!register_operand (operands[3], E_VOIDmode)
                      || !
#line 4098 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_337 (insn, operands);

                default:
                  return NULL;
                }

            case IF_THEN_ELSE:
              switch (pattern78 (x1))
                {
                case 0:
                  if (!(
#line 10071 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10080 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_391 (insn, operands);

                case 1:
                  if (!(
#line 10157 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH) && 
#line 10166 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_393 (insn, operands);

                case 2:
                  if (!(
#line 10114 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10123 "../../gcc/config/s390/s390.md"
( reload_completed
   && (!REG_P (operands[3])
       || !rtx_equal_p (operands[1], operands[3])))))
                    return NULL;
                  return gen_split_392 (insn, operands);

                case 3:
                  if (!
#line 10222 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2]))))
                    return NULL;
                  return gen_split_394 (insn, operands);

                case 4:
                  if (!(
#line 10255 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH) && 
#line 10264 "../../gcc/config/s390/s390.md"
( reload_completed
   && (! REG_P (operands[2])
       || ! rtx_equal_p (operands[1], operands[2])))))
                    return NULL;
                  return gen_split_395 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case 5:
          x2 = XVECEXP (x1, 0, 0);
          if (GET_CODE (x2) != SET)
            return NULL;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return NULL;
          x14 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x14) != USE)
            return NULL;
          x3 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0)
            return NULL;
          switch (GET_CODE (operands[1]))
            {
            case CONST_INT:
              if (!const_int_operand (operands[1], E_VOIDmode))
                return NULL;
              x21 = XEXP (x3, 0);
              operands[2] = x21;
              if (!immediate_operand (operands[2], E_VOIDmode))
                return NULL;
              x20 = XVECEXP (x1, 0, 3);
              x22 = XEXP (x20, 0);
              operands[3] = x22;
              if (!scratch_operand (operands[3], E_VOIDmode)
                  || !
#line 3861 "../../gcc/config/s390/s390.md"
(reload_completed))
                return NULL;
              return gen_split_330 (insn, operands);

            case REG:
            case SUBREG:
              if (!register_operand (operands[1], E_VOIDmode))
                return NULL;
              x21 = XEXP (x3, 0);
              switch (GET_CODE (x21))
                {
                case SUBREG:
                case MEM:
                  operands[2] = x21;
                  if (!memory_operand (operands[2], E_VOIDmode))
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x22 = XEXP (x20, 0);
                  operands[3] = x22;
                  if (!scratch_operand (operands[3], E_VOIDmode)
                      || !
#line 3875 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_331 (insn, operands);

                case CONST:
                  if (GET_MODE (x21) != E_BLKmode)
                    return NULL;
                  x23 = XEXP (x21, 0);
                  if (GET_CODE (x23) != UNSPEC
                      || XVECLEN (x23, 0) != 1
                      || XINT (x23, 1) != 17
                      || GET_MODE (x23) != E_BLKmode)
                    return NULL;
                  x24 = XVECEXP (x23, 0, 0);
                  if (x24 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                    return NULL;
                  x20 = XVECEXP (x1, 0, 3);
                  x22 = XEXP (x20, 0);
                  operands[2] = x22;
                  if (scratch_operand (operands[2], E_VOIDmode)
                      && 
#line 3891 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && reload_completed))
                    return gen_split_332 (insn, operands);
                  if (!register_operand (operands[2], E_VOIDmode)
                      || !
#line 3907 "../../gcc/config/s390/s390.md"
(reload_completed))
                    return NULL;
                  return gen_split_333 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
