/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern3 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern0 (x3, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern0 (x3, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern0 (x3, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern0 (x3, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern0 (x3, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern0 (x3, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern0 (x3, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern0 (x3, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern0 (x3, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern0 (x3, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern0 (x3, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern0 (x3, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern0 (x3, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern0 (x3, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1TImode:
      if (pattern0 (x3, 
E_V1TImode) != 0)
        return -1;
      return 14;

    case E_TImode:
      if (pattern0 (x3, 
E_TImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern0 (x3, 
E_V4SFmode) != 0)
        return -1;
      return 16;

    case E_V2DFmode:
      if (pattern0 (x3, 
E_V2DFmode) != 0)
        return -1;
      return 17;

    case E_V1TFmode:
      if (pattern0 (x3, 
E_V1TFmode) != 0)
        return -1;
      return 18;

    case E_TFmode:
      if (pattern0 (x3, 
E_TFmode) != 0)
        return -1;
      return 19;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int i1, int i2, int i3, int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_V4SFmode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (GET_CODE (x3) != VEC_SELECT
      || GET_MODE (x3) != E_V4HImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != PARALLEL
      || XVECLEN (x4, 0) != 4)
    return -1;
  x5 = XVECEXP (x4, 0, 0);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + i4])
    return -1;
  x6 = XVECEXP (x4, 0, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + i3])
    return -1;
  x7 = XVECEXP (x4, 0, 2);
  if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + i2])
    return -1;
  x8 = XVECEXP (x4, 0, 3);
  if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + i1])
    return -1;
  x9 = XEXP (x1, 0);
  operands[0] = x9;
  if (!register_operand (operands[0], E_V4SFmode))
    return -1;
  x10 = XEXP (x3, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_V8HImode))
    return -1;
  x11 = XVECEXP (x2, 0, 1);
  operands[2] = x11;
  if (!const_mask_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern33 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_CODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 0);
  operands[2] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      return pattern32 (x1, 
E_V8HImode, 
E_V8QImode, 
E_V16QImode); /* [-1, 0] */

    case E_V8HImode:
      if (pattern32 (x1, 
E_V4SImode, 
E_V4HImode, 
E_V8HImode) != 0)
        return -1;
      return 1;

    case E_V4SImode:
      if (pattern32 (x1, 
E_V2DImode, 
E_V2SImode, 
E_V4SImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern40 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_DImode)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 33
      || GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x2, 0);
  operands[0] = x6;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x7 = XEXP (x3, 0);
  operands[1] = x7;
  if (!register_operand (operands[1], E_DImode))
    return -1;
  return 0;
}

int
pattern49 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || GET_MODE (x1) != E_V4SFmode
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || GET_MODE (x1) != E_V2DFmode
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || GET_MODE (x1) != E_V1TFmode
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 4;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 5;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 6;

    case E_TDmode:
      if (!register_operand (operands[0], E_TDmode)
          || GET_MODE (x1) != E_TDmode
          || !register_operand (operands[1], E_TDmode))
        return -1;
      return 7;

    case E_DDmode:
      if (!register_operand (operands[0], E_DDmode)
          || GET_MODE (x1) != E_DDmode
          || !register_operand (operands[1], E_DDmode))
        return -1;
      return 8;

    default:
      return -1;
    }
}

int
pattern72 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 33
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  x6 = XEXP (x4, 1);
  x7 = XEXP (x6, 0);
  operands[1] = x7;
  if (!s_operand (operands[1], E_QImode))
    return -1;
  x8 = XEXP (x6, 1);
  operands[2] = x8;
  if (!nonzero_shift_count_operand (operands[2], E_VOIDmode))
    return -1;
  return pattern71 (x6); /* [-1, 1] */
}

int
pattern80 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 0;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern87 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_DFmode:
      if (!nonimmediate_operand (operands[1], E_DFmode))
        return -1;
      return 0;

    case E_SFmode:
      if (!nonimmediate_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  x5 = XEXP (x1, 1);
  operands[3] = x5;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern94 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern94 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern101 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  x4 = XEXP (x2, 1);
  operands[4] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_V1QImode:
      return pattern99 (x1, 
E_V1QImode); /* [-1, 0] */

    case E_V2QImode:
      if (pattern99 (x1, 
E_V2QImode) != 0)
        return -1;
      return 1;

    case E_V4QImode:
      if (pattern99 (x1, 
E_V4QImode) != 0)
        return -1;
      return 2;

    case E_V8QImode:
      if (pattern99 (x1, 
E_V8QImode) != 0)
        return -1;
      return 3;

    case E_V16QImode:
      if (pattern99 (x1, 
E_V16QImode) != 0)
        return -1;
      return 4;

    case E_V1HImode:
      if (pattern99 (x1, 
E_V1HImode) != 0)
        return -1;
      return 5;

    case E_V2HImode:
      if (pattern99 (x1, 
E_V2HImode) != 0)
        return -1;
      return 6;

    case E_V4HImode:
      if (pattern99 (x1, 
E_V4HImode) != 0)
        return -1;
      return 7;

    case E_V8HImode:
      if (pattern99 (x1, 
E_V8HImode) != 0)
        return -1;
      return 8;

    case E_V1SImode:
      if (pattern99 (x1, 
E_V1SImode) != 0)
        return -1;
      return 9;

    case E_V2SImode:
      if (pattern99 (x1, 
E_V2SImode) != 0)
        return -1;
      return 10;

    case E_V4SImode:
      if (pattern99 (x1, 
E_V4SImode) != 0)
        return -1;
      return 11;

    case E_V1DImode:
      if (pattern99 (x1, 
E_V1DImode) != 0)
        return -1;
      return 12;

    case E_V2DImode:
      if (pattern99 (x1, 
E_V2DImode) != 0)
        return -1;
      return 13;

    case E_V1SFmode:
      if (pattern100 (x1, 
E_V1SFmode, 
E_V1SImode) != 0)
        return -1;
      return 14;

    case E_V2SFmode:
      if (pattern100 (x1, 
E_V2SFmode, 
E_V2SImode) != 0)
        return -1;
      return 15;

    case E_V4SFmode:
      if (pattern100 (x1, 
E_V4SFmode, 
E_V4SImode) != 0)
        return -1;
      return 16;

    case E_V1DFmode:
      if (pattern100 (x1, 
E_V1DFmode, 
E_V1DImode) != 0)
        return -1;
      return 17;

    case E_V2DFmode:
      if (pattern100 (x1, 
E_V2DFmode, 
E_V2DImode) != 0)
        return -1;
      return 18;

    default:
      return -1;
    }
}

int
pattern133 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern137 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !nonimmediate_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern143 (rtx x1, int i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_CCRAWmode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 33
      || GET_MODE (x4) != E_CCRAWmode)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != SET)
    return -1;
  x6 = XEXP (x5, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 2
      || XINT (x6, 1) != i1)
    return -1;
  x7 = XEXP (x5, 0);
  operands[0] = x7;
  x8 = XVECEXP (x6, 0, 0);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  x9 = XVECEXP (x6, 0, 1);
  if (!rtx_equal_p (x9, operands[2]))
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_V8HImode:
      return pattern142 (x6, 
E_V16QImode, 
E_V8HImode); /* [-1, 0] */

    case E_V4SImode:
      if (pattern142 (x6, 
E_V8HImode, 
E_V4SImode) != 0)
        return -1;
      return 1;

    case E_V2DImode:
      if (pattern142 (x6, 
E_V4SImode, 
E_V2DImode) != 0)
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern153 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i2)
      || GET_MODE (x1) != i2
      || !register_operand (operands[1], i2)
      || !register_operand (operands[2], i2)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern158 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  if (GET_MODE (x8) != i1)
    return -1;
  return 0;
}

int
pattern167 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || GET_MODE (x1) != i1)
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_V4SFmode:
      if (!register_operand (operands[0], E_V4SFmode)
          || !register_operand (operands[1], E_V4SFmode))
        return -1;
      return 0;

    case E_V2DFmode:
      if (!register_operand (operands[0], E_V2DFmode)
          || !register_operand (operands[1], E_V2DFmode))
        return -1;
      return 1;

    case E_V1TFmode:
      if (!register_operand (operands[0], E_V1TFmode)
          || !register_operand (operands[1], E_V1TFmode))
        return -1;
      return 2;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x1) != E_DImode
          || !register_operand (operands[1], E_DImode))
        return -1;
      return 0;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 1;

    case E_TFmode:
      if (!register_operand (operands[0], E_TFmode)
          || GET_MODE (x1) != E_TFmode
          || !register_operand (operands[1], E_TFmode))
        return -1;
      return 2;

    case E_FPRX2mode:
      if (!register_operand (operands[0], E_FPRX2mode)
          || GET_MODE (x1) != E_FPRX2mode
          || !register_operand (operands[1], E_FPRX2mode))
        return -1;
      return 3;

    case E_DFmode:
      if (!register_operand (operands[0], E_DFmode)
          || GET_MODE (x1) != E_DFmode
          || !register_operand (operands[1], E_DFmode))
        return -1;
      return 4;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x1) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 5;

    default:
      return -1;
    }
}

int
pattern199 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!nonimmediate_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !nonimmediate_operand (operands[1], i1)
      || !contiguous_bitmask_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !nonimmediate_operand (operands[3], i1)
      || !const_int_operand (operands[4], i1))
    return -1;
  return 0;
}

int
pattern206 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1)
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_DImode:
      return pattern214 (x1, 
E_DImode); /* [-1, 0] */

    case E_SImode:
      if (pattern214 (x1, 
E_SImode) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern227 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern235 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_MODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = XEXP (x6, 1);
  if (!rtx_equal_p (x8, operands[1]))
    return -1;
  return 0;
}

int
pattern242 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], i1))
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern250 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  x6 = XEXP (x2, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 0);
  operands[3] = x8;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  if (!rtx_equal_p (x10, operands[2]))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  if (!rtx_equal_p (x12, operands[3]))
    return -1;
  switch (SUBREG_BYTE (x7))
    {
    case 0:
      if (maybe_ne (SUBREG_BYTE (x4), 0))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_TImode:
          return pattern256 (x2, 
E_TImode, 
E_DImode); /* [-1, 0] */

        case E_DImode:
          if (pattern256 (x2, 
E_DImode, 
E_SImode) != 0)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 4:
      if (GET_MODE (x7) != E_SImode
          || maybe_ne (SUBREG_BYTE (x4), 4)
          || GET_MODE (x4) != E_SImode
          || !register_operand (operands[0], E_TImode)
          || !register_operand (operands[1], E_TImode)
          || !register_operand (operands[2], E_TImode)
          || !register_operand (operands[3], E_TImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern283 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i2
      || !nonimmediate_operand (operands[1], i1)
      || !addv_const_operand (operands[2], i2)
      || pattern281 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern290 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !general_operand (operands[2], i1)
      || !register_operand (operands[3], i1)
      || !scratch_operand (operands[1], i1))
    return -1;
  return 0;
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XVECEXP (x2, 0, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_V16QImode:
      if (!register_operand (operands[0], E_V16QImode)
          || GET_MODE (x2) != E_V16QImode
          || !register_operand (operands[1], E_V16QImode))
        return -1;
      if (
#line 1459 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return 938; /* popcountv16qi2_vxe */
      if (!
#line 1467 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE))
        return -1;
      return 942; /* popcountv16qi2_vx */

    case E_V8HImode:
      if (!register_operand (operands[0], E_V8HImode)
          || GET_MODE (x2) != E_V8HImode
          || !register_operand (operands[1], E_V8HImode)
          || !
#line 1459 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 939; /* popcountv8hi2_vxe */

    case E_V4SImode:
      if (!register_operand (operands[0], E_V4SImode)
          || GET_MODE (x2) != E_V4SImode
          || !register_operand (operands[1], E_V4SImode)
          || !
#line 1459 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 940; /* popcountv4si2_vxe */

    case E_V2DImode:
      if (!register_operand (operands[0], E_V2DImode)
          || GET_MODE (x2) != E_V2DImode
          || !register_operand (operands[1], E_V2DImode)
          || !
#line 1459 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
        return -1;
      return 941; /* popcountv2di2_vxe */

    case E_DImode:
      if (pattern104 (x2, pnum_clobbers, 
E_DImode) != 0
          || !(
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196) && 
#line 795 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      *pnum_clobbers = 1;
      return 2655; /* *popcountdi_z196 */

    case E_SImode:
      if (pattern104 (x2, pnum_clobbers, 
E_SImode) != 0
          || !
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2656; /* *popcountsi_z196 */

    case E_HImode:
      if (pattern104 (x2, pnum_clobbers, 
E_HImode) != 0
          || !
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2657; /* *popcounthi_z196 */

    case E_QImode:
      if (pattern104 (x2, pnum_clobbers, 
E_QImode) != 0
          || !
#line 12120 "../../gcc/config/s390/s390.md"
(TARGET_Z196))
        return -1;
      *pnum_clobbers = 1;
      return 2658; /* *popcountqi_z196 */

    default:
      return -1;
    }
}

 int
recog_11 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern28 (x1))
    {
    case 0:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1183; /* vec_widen_smult_even_v1qi */

    case 1:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1184; /* vec_widen_smult_even_v2qi */

    case 2:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1185; /* vec_widen_smult_even_v4qi */

    case 3:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1186; /* vec_widen_smult_even_v8qi */

    case 4:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1187; /* vec_widen_smult_even_v16qi */

    case 5:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1188; /* vec_widen_smult_even_v1hi */

    case 6:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1189; /* vec_widen_smult_even_v2hi */

    case 7:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1190; /* vec_widen_smult_even_v4hi */

    case 8:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1191; /* vec_widen_smult_even_v8hi */

    case 9:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1192; /* vec_widen_smult_even_v1si */

    case 10:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1193; /* vec_widen_smult_even_v2si */

    case 11:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1194; /* vec_widen_smult_even_v4si */

    case 12:
      if (!
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX))
        return -1;
      return 1195; /* vec_widen_smult_even_v1di */

    case 13:
      if (!(
#line 1838 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 71 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
        return -1;
      return 1196; /* vec_widen_smult_even_v2di */

    default:
      return -1;
    }
}

 int
recog_22 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case AND:
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != NOT)
                return -1;
              operands[3] = x5;
              x8 = XEXP (x6, 1);
              operands[2] = x8;
              x9 = XEXP (x7, 0);
              if (!rtx_equal_p (x9, operands[3]))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_V16QImode:
                  if (pattern220 (x2, 
E_V16QImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 46; /* vselv16qi */

                case E_V8HImode:
                  if (pattern220 (x2, 
E_V8HImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 47; /* vselv8hi */

                case E_V4SImode:
                  if (pattern220 (x2, 
E_V4SImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 48; /* vselv4si */

                case E_V2DImode:
                  if (pattern220 (x2, 
E_V2DImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 49; /* vselv2di */

                case E_V1TImode:
                  if (pattern220 (x2, 
E_V1TImode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 50; /* vselv1ti */

                case E_V1DFmode:
                  if (pattern220 (x2, 
E_V1DFmode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 51; /* vselv1df */

                case E_V2DFmode:
                  if (pattern220 (x2, 
E_V2DFmode) != 0
                      || !
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
                    return -1;
                  return 52; /* vselv2df */

                case E_V1SFmode:
                  if (pattern220 (x2, 
E_V1SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 53; /* vselv1sf */

                case E_V2SFmode:
                  if (pattern220 (x2, 
E_V2SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 54; /* vselv2sf */

                case E_V4SFmode:
                  if (pattern220 (x2, 
E_V4SFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 55; /* vselv4sf */

                case E_V1TFmode:
                  if (pattern220 (x2, 
E_V1TFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 56; /* vselv1tf */

                case E_TFmode:
                  if (pattern220 (x2, 
E_TFmode) != 0
                      || !(
#line 529 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                    return -1;
                  return 57; /* vseltf */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
              operands[3] = x6;
              operands[2] = x5;
              switch (GET_MODE (operands[0]))
                {
                case E_V1QImode:
                  if (pattern8 (x2, 
E_V1QImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1594; /* *vevalv1qi_iorand */

                case E_V2QImode:
                  if (pattern8 (x2, 
E_V2QImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1603; /* *vevalv2qi_iorand */

                case E_V4QImode:
                  if (pattern8 (x2, 
E_V4QImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1612; /* *vevalv4qi_iorand */

                case E_V8QImode:
                  if (pattern8 (x2, 
E_V8QImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1621; /* *vevalv8qi_iorand */

                case E_V16QImode:
                  if (pattern8 (x2, 
E_V16QImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1630; /* *vevalv16qi_iorand */

                case E_V1HImode:
                  if (pattern8 (x2, 
E_V1HImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1639; /* *vevalv1hi_iorand */

                case E_V2HImode:
                  if (pattern8 (x2, 
E_V2HImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1648; /* *vevalv2hi_iorand */

                case E_V4HImode:
                  if (pattern8 (x2, 
E_V4HImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1657; /* *vevalv4hi_iorand */

                case E_V8HImode:
                  if (pattern8 (x2, 
E_V8HImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1666; /* *vevalv8hi_iorand */

                case E_V1SImode:
                  if (pattern8 (x2, 
E_V1SImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1675; /* *vevalv1si_iorand */

                case E_V2SImode:
                  if (pattern8 (x2, 
E_V2SImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1684; /* *vevalv2si_iorand */

                case E_V4SImode:
                  if (pattern8 (x2, 
E_V4SImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1693; /* *vevalv4si_iorand */

                case E_V1DImode:
                  if (pattern8 (x2, 
E_V1DImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1702; /* *vevalv1di_iorand */

                case E_V2DImode:
                  if (pattern8 (x2, 
E_V2DImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1711; /* *vevalv2di_iorand */

                case E_V1TImode:
                  if (pattern8 (x2, 
E_V1TImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1720; /* *vevalv1ti_iorand */

                case E_TImode:
                  if (pattern8 (x2, 
E_TImode) != 0
                      || !
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3))
                    return -1;
                  return 1729; /* *vevalti_iorand */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          x6 = XEXP (x2, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTRACT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              if (!const_int_operand (operands[4], E_VOIDmode))
                return -1;
              x10 = XEXP (x6, 2);
              operands[5] = x10;
              if (!const_int_operand (operands[5], E_VOIDmode))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern242 (x2, 
E_DImode) != 0)
                    return -1;
                  if (
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1944; /* *risbgn_ior_and_sr_zedi */
                  if (pnum_clobbers == NULL
                      || !
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 64)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1945; /* *risbg_ior_and_sr_zedi */

                case E_SImode:
                  if (pattern242 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return 1946; /* *risbgn_ior_and_sr_zesi */
                  if (pnum_clobbers == NULL
                      || !
#line 4352 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[4]), INTVAL (operands[5]), 32)
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_M1U << UINTVAL (operands[4]))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1947; /* *risbg_ior_and_sr_zesi */

                default:
                  return -1;
                }

            case AND:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern199 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1972; /* *insvdi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !(
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1973; /* *insvdi_clobbercc_noshift */

                case E_SImode:
                  if (pattern199 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return 1974; /* *insvsi_nocc_noshift */
                  if (pnum_clobbers == NULL
                      || !
#line 4502 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && INTVAL (operands[2]) == ~INTVAL (operands[4])))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1975; /* *insvsi_clobbercc_noshift */

                default:
                  return -1;
                }

            case ASHIFT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern200 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1978; /* *insvdi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !(
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1979; /* *insvdi_clobbercc_appendbitsleft */

                case E_SImode:
                  if (pattern200 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return 1980; /* *insvsi_nocc_appendbitsleft */
                  if (pnum_clobbers == NULL
                      || !
#line 4556 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && UINTVAL (operands[2]) == (HOST_WIDE_INT_1U << UINTVAL (operands[4])) - 1))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1981; /* *insvsi_clobbercc_appendbitsleft */

                default:
                  return -1;
                }

            case LSHIFTRT:
              x7 = XEXP (x6, 0);
              operands[3] = x7;
              x8 = XEXP (x6, 1);
              operands[4] = x8;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern201 (x2, 
E_DImode) != 0)
                    return -1;
                  if ((
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return 1982; /* *risbgn_di_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !(
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (DImode) - UINTVAL (operands[4])))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1983; /* *risbg_di_ior_and_lshiftrt */

                case E_SImode:
                  if (pattern201 (x2, 
E_SImode) != 0)
                    return -1;
                  if (
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return 1984; /* *risbgn_si_ior_and_lshiftrt */
                  if (pnum_clobbers == NULL
                      || !
#line 4571 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12 && UINTVAL (operands[2])
   == (HOST_WIDE_INT_M1U
       << (GET_MODE_BITSIZE (SImode) - UINTVAL (operands[4])))))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1985; /* *risbg_si_ior_and_lshiftrt */

                default:
                  return -1;
                }

            case REG:
            case SUBREG:
            case MEM:
              if (GET_CODE (x6) == SUBREG
                  && known_eq (SUBREG_BYTE (x6), 4)
                  && GET_MODE (x6) == E_SImode)
                {
                  res = recog_21 (x1, insn, pnum_clobbers);
                  if (res >= 0)
                    return res;
                }
              if (pnum_clobbers == NULL)
                return -1;
              operands[3] = x6;
              switch (GET_MODE (operands[0]))
                {
                case E_DImode:
                  if (pattern188 (x2, 
E_DImode) != 0
                      || !(
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1992; /* *rosbg_di_noshift */

                case E_SImode:
                  if (pattern188 (x2, 
E_SImode) != 0
                      || !
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                    return -1;
                  *pnum_clobbers = 1;
                  return 1994; /* *rosbg_si_noshift */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case NOT:
      x6 = XEXP (x2, 1);
      if (GET_CODE (x6) != AND)
        return -1;
      x11 = XEXP (x4, 0);
      operands[3] = x11;
      x5 = XEXP (x3, 1);
      operands[1] = x5;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      x7 = XEXP (x6, 0);
      if (!rtx_equal_p (x7, operands[3]))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern185 (x2, 
E_V16QImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 58; /* *vselv16qi_swapped */

        case E_V8HImode:
          if (pattern185 (x2, 
E_V8HImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 59; /* *vselv8hi_swapped */

        case E_V4SImode:
          if (pattern185 (x2, 
E_V4SImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 60; /* *vselv4si_swapped */

        case E_V2DImode:
          if (pattern185 (x2, 
E_V2DImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 61; /* *vselv2di_swapped */

        case E_V1TImode:
          if (pattern185 (x2, 
E_V1TImode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 62; /* *vselv1ti_swapped */

        case E_V1DFmode:
          if (pattern185 (x2, 
E_V1DFmode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 63; /* *vselv1df_swapped */

        case E_V2DFmode:
          if (pattern185 (x2, 
E_V2DFmode) != 0
              || !
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 64; /* *vselv2df_swapped */

        case E_V1SFmode:
          if (pattern185 (x2, 
E_V1SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 65; /* *vselv1sf_swapped */

        case E_V2SFmode:
          if (pattern185 (x2, 
E_V2SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 82 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 66; /* *vselv2sf_swapped */

        case E_V4SFmode:
          if (pattern185 (x2, 
E_V4SFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 67; /* *vselv4sf_swapped */

        case E_V1TFmode:
          if (pattern185 (x2, 
E_V1TFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 83 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 68; /* *vselv1tf_swapped */

        case E_TFmode:
          if (pattern185 (x2, 
E_TFmode) != 0
              || !(
#line 540 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 84 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 69; /* *vseltf_swapped */

        default:
          return -1;
        }

    case ROTATE:
      if (pattern60 (x2, pnum_clobbers) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      operands[2] = x5;
      if (!contiguous_bitmask_operand (operands[2], E_DImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[4] = x6;
      if (!nonimmediate_operand (operands[4], E_DImode)
          || !
#line 4700 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return -1;
      *pnum_clobbers = 1;
      return 1996; /* *rosbg_di_rotl */

    case LSHIFTRT:
      switch (pattern63 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 1998; /* *rosbg_di_srl_bitmask */

        case 1:
          if (!
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 2000; /* *rosbg_si_srl_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern63 (x2, pnum_clobbers))
        {
        case 0:
          if (!(
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2002; /* *rosbg_di_sll_bitmask */

        case 1:
          if (!
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          *pnum_clobbers = 1;
          return 2004; /* *rosbg_si_sll_bitmask */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != CONST_INT)
    return -1;
  operands[1] = x3;
  if (const_int_operand (operands[1], E_VOIDmode))
    {
      res = recog_42 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_DImode))
    return -1;
  x5 = XEXP (x1, 1);
  if (!const_int_operand (x5, E_DImode))
    return -1;
  switch (XWINT (x3, 0))
    {
    case 16L:
      x6 = XEXP (x2, 2);
      operands[1] = x6;
      if (!const_int_operand (operands[1], E_VOIDmode))
        return -1;
      operands[2] = x5;
      if (!
#line 4901 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH
   && EXTRACT_ARGS_IN_RANGE (16, INTVAL (operands[1]), 64)
   && INTVAL (operands[1]) >= 0
   && INTVAL (operands[1]) < BITS_PER_WORD
   && INTVAL (operands[1]) % 16 == 0))
        return -1;
      return 2021; /* *insvdi_reg_imm */

    case 32L:
      x6 = XEXP (x2, 2);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      operands[1] = x5;
      switch (XWINT (x6, 0))
        {
        case 0L:
          if (!
#line 4925 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2022; /* *insv_h_di_reg_extimm */

        case 32L:
          if (!
#line 4936 "../../gcc/config/s390/s390.md"
(TARGET_EXTIMM))
            return -1;
          return 2023; /* *insv_l_di_reg_extimm */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_50 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 2781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1520; /* zero_extendv2qiv2hi2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 2781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1522; /* zero_extendv2hiv2si2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 2781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1524; /* zero_extendv2siv2di2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 2781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1526; /* zero_extendv4qiv4hi2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 2781 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1528; /* zero_extendv4hiv4si2 */

        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x3) != E_HImode
              || !memory_operand (operands[1], E_QImode))
            return -1;
          if (
#line 5333 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && !TARGET_EXTIMM))
            return 2054; /* *zero_extendqihi2_64 */
          if (!
#line 5341 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH))
            return -1;
          return 2055; /* *zero_extendqihi2_31 */

        default:
          return -1;
        }

    case VEC_SELECT:
      switch (pattern114 (x3))
        {
        case 0:
          if (!
#line 2837 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1531; /* vec_unpacku_hi_v16qi */

        case 1:
          if (!
#line 2848 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1532; /* vec_unpacku_lo_v16qi */

        case 2:
          if (!
#line 2884 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1535; /* vec_unpacku_hi_v8hi */

        case 3:
          if (!
#line 2894 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1536; /* vec_unpacku_lo_v8hi */

        case 4:
          if (!
#line 2930 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1539; /* vec_unpacku_hi_v4si */

        case 5:
          if (!
#line 2940 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1540; /* vec_unpacku_lo_v4si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case IOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V16QImode:
          if (pattern105 (x3, 
E_V16QImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 194; /* vec_norv16qi3 */

        case E_V8HImode:
          if (pattern105 (x3, 
E_V8HImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 195; /* vec_norv8hi3 */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 196; /* vec_norv4si3 */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 197; /* vec_norv2di3 */

        case E_V2DFmode:
          if (pattern105 (x3, 
E_V2DFmode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 198; /* vec_norv2df3 */

        case E_V1TImode:
          if (pattern105 (x3, 
E_V1TImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 199; /* vec_norv1ti3 */

        case E_TImode:
          if (pattern105 (x3, 
E_TImode) != 0
              || !
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX))
            return -1;
          return 200; /* vec_norti3 */

        case E_V4SFmode:
          if (pattern105 (x3, 
E_V4SFmode) != 0
              || !(
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 201; /* vec_norv4sf3 */

        case E_V1TFmode:
          if (pattern105 (x3, 
E_V1TFmode) != 0
              || !(
#line 1017 "../../gcc/config/s390/vx-builtins.md"
(TARGET_VX) && 
#line 47 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 202; /* vec_norv1tf3 */

        default:
          return -1;
        }

    case XOR:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (pattern105 (x3, 
E_V1QImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 894; /* notxorv1qi3 */

        case E_V2QImode:
          if (pattern105 (x3, 
E_V2QImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 895; /* notxorv2qi3 */

        case E_V4QImode:
          if (pattern105 (x3, 
E_V4QImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 896; /* notxorv4qi3 */

        case E_V8QImode:
          if (pattern105 (x3, 
E_V8QImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 897; /* notxorv8qi3 */

        case E_V16QImode:
          if (pattern105 (x3, 
E_V16QImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 898; /* notxorv16qi3 */

        case E_V1HImode:
          if (pattern105 (x3, 
E_V1HImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 899; /* notxorv1hi3 */

        case E_V2HImode:
          if (pattern105 (x3, 
E_V2HImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 900; /* notxorv2hi3 */

        case E_V4HImode:
          if (pattern105 (x3, 
E_V4HImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 901; /* notxorv4hi3 */

        case E_V8HImode:
          if (pattern105 (x3, 
E_V8HImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 902; /* notxorv8hi3 */

        case E_V1SImode:
          if (pattern105 (x3, 
E_V1SImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 903; /* notxorv1si3 */

        case E_V2SImode:
          if (pattern105 (x3, 
E_V2SImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 904; /* notxorv2si3 */

        case E_V4SImode:
          if (pattern105 (x3, 
E_V4SImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 905; /* notxorv4si3 */

        case E_V1DImode:
          if (pattern105 (x3, 
E_V1DImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 906; /* notxorv1di3 */

        case E_V2DImode:
          if (pattern105 (x3, 
E_V2DImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 907; /* notxorv2di3 */

        case E_V1SFmode:
          if (pattern105 (x3, 
E_V1SFmode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 908; /* notxorv1sf3 */

        case E_V2SFmode:
          if (pattern105 (x3, 
E_V2SFmode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 909; /* notxorv2sf3 */

        case E_V4SFmode:
          if (pattern105 (x3, 
E_V4SFmode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 910; /* notxorv4sf3 */

        case E_V1DFmode:
          if (pattern105 (x3, 
E_V1DFmode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 911; /* notxorv1df3 */

        case E_V2DFmode:
          if (pattern105 (x3, 
E_V2DFmode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 912; /* notxorv2df3 */

        case E_V1TFmode:
          if (pattern105 (x3, 
E_V1TFmode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 913; /* notxorv1tf3 */

        case E_V1TImode:
          if (pattern105 (x3, 
E_V1TImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 914; /* notxorv1ti3 */

        case E_TImode:
          if (pattern105 (x3, 
E_TImode) != 0
              || !
#line 1427 "../../gcc/config/s390/vector.md"
(TARGET_VXE))
            return -1;
          return 915; /* notxorti3 */

        case E_DImode:
          if (pnum_clobbers == NULL
              || pattern105 (x3, 
E_DImode) != 0
              || !(
#line 9066 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2432; /* *nxordi */

        case E_SImode:
          if (pnum_clobbers == NULL
              || pattern105 (x3, 
E_SImode) != 0
              || !
#line 9066 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2433; /* *nxorsi */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_V1QImode:
          if (!register_operand (operands[0], E_V1QImode)
              || GET_MODE (x3) != E_V1QImode
              || !register_operand (operands[1], E_V1QImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 916; /* one_cmplv1qi2 */

        case E_V2QImode:
          if (!register_operand (operands[0], E_V2QImode)
              || GET_MODE (x3) != E_V2QImode
              || !register_operand (operands[1], E_V2QImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 917; /* one_cmplv2qi2 */

        case E_V4QImode:
          if (!register_operand (operands[0], E_V4QImode)
              || GET_MODE (x3) != E_V4QImode
              || !register_operand (operands[1], E_V4QImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 918; /* one_cmplv4qi2 */

        case E_V8QImode:
          if (!register_operand (operands[0], E_V8QImode)
              || GET_MODE (x3) != E_V8QImode
              || !register_operand (operands[1], E_V8QImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 919; /* one_cmplv8qi2 */

        case E_V16QImode:
          if (!register_operand (operands[0], E_V16QImode)
              || GET_MODE (x3) != E_V16QImode
              || !register_operand (operands[1], E_V16QImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 920; /* one_cmplv16qi2 */

        case E_V1HImode:
          if (!register_operand (operands[0], E_V1HImode)
              || GET_MODE (x3) != E_V1HImode
              || !register_operand (operands[1], E_V1HImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 921; /* one_cmplv1hi2 */

        case E_V2HImode:
          if (!register_operand (operands[0], E_V2HImode)
              || GET_MODE (x3) != E_V2HImode
              || !register_operand (operands[1], E_V2HImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 922; /* one_cmplv2hi2 */

        case E_V4HImode:
          if (!register_operand (operands[0], E_V4HImode)
              || GET_MODE (x3) != E_V4HImode
              || !register_operand (operands[1], E_V4HImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 923; /* one_cmplv4hi2 */

        case E_V8HImode:
          if (!register_operand (operands[0], E_V8HImode)
              || GET_MODE (x3) != E_V8HImode
              || !register_operand (operands[1], E_V8HImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 924; /* one_cmplv8hi2 */

        case E_V1SImode:
          if (!register_operand (operands[0], E_V1SImode)
              || GET_MODE (x3) != E_V1SImode
              || !register_operand (operands[1], E_V1SImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 925; /* one_cmplv1si2 */

        case E_V2SImode:
          if (!register_operand (operands[0], E_V2SImode)
              || GET_MODE (x3) != E_V2SImode
              || !register_operand (operands[1], E_V2SImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 926; /* one_cmplv2si2 */

        case E_V4SImode:
          if (!register_operand (operands[0], E_V4SImode)
              || GET_MODE (x3) != E_V4SImode
              || !register_operand (operands[1], E_V4SImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 927; /* one_cmplv4si2 */

        case E_V1DImode:
          if (!register_operand (operands[0], E_V1DImode)
              || GET_MODE (x3) != E_V1DImode
              || !register_operand (operands[1], E_V1DImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 928; /* one_cmplv1di2 */

        case E_V2DImode:
          if (!register_operand (operands[0], E_V2DImode)
              || GET_MODE (x3) != E_V2DImode
              || !register_operand (operands[1], E_V2DImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 929; /* one_cmplv2di2 */

        case E_V1SFmode:
          if (!register_operand (operands[0], E_V1SFmode)
              || GET_MODE (x3) != E_V1SFmode
              || !register_operand (operands[1], E_V1SFmode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 930; /* one_cmplv1sf2 */

        case E_V2SFmode:
          if (!register_operand (operands[0], E_V2SFmode)
              || GET_MODE (x3) != E_V2SFmode
              || !register_operand (operands[1], E_V2SFmode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 931; /* one_cmplv2sf2 */

        case E_V4SFmode:
          if (!register_operand (operands[0], E_V4SFmode)
              || GET_MODE (x3) != E_V4SFmode
              || !register_operand (operands[1], E_V4SFmode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 932; /* one_cmplv4sf2 */

        case E_V1DFmode:
          if (!register_operand (operands[0], E_V1DFmode)
              || GET_MODE (x3) != E_V1DFmode
              || !register_operand (operands[1], E_V1DFmode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 933; /* one_cmplv1df2 */

        case E_V2DFmode:
          if (!register_operand (operands[0], E_V2DFmode)
              || GET_MODE (x3) != E_V2DFmode
              || !register_operand (operands[1], E_V2DFmode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 934; /* one_cmplv2df2 */

        case E_V1TFmode:
          if (!register_operand (operands[0], E_V1TFmode)
              || GET_MODE (x3) != E_V1TFmode
              || !register_operand (operands[1], E_V1TFmode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 935; /* one_cmplv1tf2 */

        case E_V1TImode:
          if (!register_operand (operands[0], E_V1TImode)
              || GET_MODE (x3) != E_V1TImode
              || !register_operand (operands[1], E_V1TImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 936; /* one_cmplv1ti2 */

        case E_TImode:
          if (!register_operand (operands[0], E_TImode)
              || GET_MODE (x3) != E_TImode
              || !register_operand (operands[1], E_TImode)
              || !
#line 1435 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 937; /* one_cmplti2 */

        case E_DImode:
          if (pattern83 (x3, pnum_clobbers, 
E_DImode) != 0
              || !(
#line 8661 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          *pnum_clobbers = 1;
          return 2415; /* *notdi */

        case E_SImode:
          if (pattern83 (x3, pnum_clobbers, 
E_SImode) != 0
              || !
#line 8661 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
            return -1;
          *pnum_clobbers = 1;
          return 2416; /* *notsi */

        default:
          return -1;
        }

    case UNGE:
      x5 = XEXP (x4, 0);
      operands[2] = x5;
      x6 = XEXP (x4, 1);
      operands[1] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern106 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1373; /* vec_cmpgtv1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern106 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1374; /* vec_cmpgtv2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern106 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1375; /* vec_cmpgtv4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern106 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1376; /* vec_cmpgtv1df_quiet_nocc */

        case E_V2DImode:
          if (pattern106 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1377; /* vec_cmpgtv2df_quiet_nocc */

        case E_V1TImode:
          if (pattern106 (x3, 
E_V1TFmode, 
E_V1TImode) != 0
              || !(
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1378; /* vec_cmpgtv1tf_quiet_nocc */

        case E_TImode:
          if (pattern106 (x3, 
E_TFmode, 
E_TImode) != 0
              || !(
#line 2375 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1379; /* vec_cmpgttf_quiet_nocc */

        default:
          return -1;
        }

    case UNLT:
      x5 = XEXP (x4, 0);
      operands[1] = x5;
      x6 = XEXP (x4, 1);
      operands[2] = x6;
      switch (GET_MODE (operands[0]))
        {
        case E_V1SImode:
          if (pattern107 (x3, 
E_V1SFmode, 
E_V1SImode) != 0
              || !(
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1380; /* vec_cmpgev1sf_quiet_nocc */

        case E_V2SImode:
          if (pattern107 (x3, 
E_V2SFmode, 
E_V2SImode) != 0
              || !(
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1381; /* vec_cmpgev2sf_quiet_nocc */

        case E_V4SImode:
          if (pattern107 (x3, 
E_V4SFmode, 
E_V4SImode) != 0
              || !(
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1382; /* vec_cmpgev4sf_quiet_nocc */

        case E_V1DImode:
          if (pattern107 (x3, 
E_V1DFmode, 
E_V1DImode) != 0
              || !
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1383; /* vec_cmpgev1df_quiet_nocc */

        case E_V2DImode:
          if (pattern107 (x3, 
E_V2DFmode, 
E_V2DImode) != 0
              || !
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return -1;
          return 1384; /* vec_cmpgev2df_quiet_nocc */

        case E_V1TImode:
          if (pattern107 (x3, 
E_V1TFmode, 
E_V1TImode) != 0
              || !(
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1385; /* vec_cmpgev1tf_quiet_nocc */

        case E_TImode:
          if (pattern107 (x3, 
E_TFmode, 
E_TImode) != 0
              || !(
#line 2392 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
            return -1;
          return 1386; /* vec_cmpgetf_quiet_nocc */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_68 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case EQ:
      switch (pattern13 (x1))
        {
        case 0:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1306; /* *vec_cmpeqv1qiv1qi_nocc */
          break;

        case 1:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1309; /* *vec_cmpeqv2qiv2qi_nocc */
          break;

        case 2:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1312; /* *vec_cmpeqv4qiv4qi_nocc */
          break;

        case 3:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1315; /* *vec_cmpeqv8qiv8qi_nocc */
          break;

        case 4:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1318; /* *vec_cmpeqv16qiv16qi_nocc */
          break;

        case 5:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1321; /* *vec_cmpeqv1hiv1hi_nocc */
          break;

        case 6:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1324; /* *vec_cmpeqv2hiv2hi_nocc */
          break;

        case 7:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1327; /* *vec_cmpeqv4hiv4hi_nocc */
          break;

        case 8:
          if (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
            return 1330; /* *vec_cmpeqv8hiv8hi_nocc */
          break;

        case 9:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1SImode)
                  && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1333; /* *vec_cmpeqv1siv1si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1SFmode)
                  && (
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1366; /* *vec_cmpeqv1sf_quiet_nocc */
            }
          break;

        case 10:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2SImode)
                  && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1336; /* *vec_cmpeqv2siv2si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2SFmode)
                  && (
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1367; /* *vec_cmpeqv2sf_quiet_nocc */
            }
          break;

        case 11:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V4SImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V4SImode)
                  && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1339; /* *vec_cmpeqv4siv4si_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V4SFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V4SFmode)
                  && (
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 74 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1368; /* *vec_cmpeqv4sf_quiet_nocc */
            }
          break;

        case 12:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1DImode)
                  && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1342; /* *vec_cmpeqv1div1di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V1DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V1DFmode)
                  && 
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1369; /* *vec_cmpeqv1df_quiet_nocc */
            }
          break;

        case 13:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V2DImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V2DImode)
                  && 
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1345; /* *vec_cmpeqv2div2di_nocc */
            }
          operands[0] = x3;
          operands[1] = x4;
          if (register_operand (operands[1], E_V2DFmode))
            {
              x5 = XEXP (x2, 1);
              operands[2] = x5;
              if (register_operand (operands[2], E_V2DFmode)
                  && 
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX))
                return 1370; /* *vec_cmpeqv2df_quiet_nocc */
            }
          break;

        case 14:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_V1TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_V1TImode)
                  && (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1348; /* *vec_cmpeqv1tiv1ti_nocc */
            }
          operands[0] = x3;
          switch (pattern110 (x2))
            {
            case 0:
              if (
#line 2249 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1354; /* *vec_cmpeqv1tiv1ti_nocc_emu */
              break;

            case 1:
              if ((
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1371; /* *vec_cmpeqv1tf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        case 15:
          x3 = XEXP (x1, 0);
          operands[2] = x3;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (register_operand (operands[0], E_TImode))
            {
              x5 = XEXP (x2, 1);
              operands[1] = x5;
              if (register_operand (operands[1], E_TImode)
                  && (
#line 2241 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 69 "../../gcc/config/s390/vector.md"
(TARGET_VXE3)))
                return 1351; /* *vec_cmpeqtiti_nocc */
            }
          operands[0] = x3;
          switch (pattern111 (x2))
            {
            case 0:
              if (
#line 2249 "../../gcc/config/s390/vector.md"
(TARGET_VX && !TARGET_VXE3))
                return 1355; /* *vec_cmpeqtiti_nocc_emu */
              break;

            case 1:
              if ((
#line 2365 "../../gcc/config/s390/vector.md"
(TARGET_VX) && 
#line 76 "../../gcc/config/s390/vector.md"
(TARGET_VXE)))
                return 1372; /* *vec_cmpeqtf_quiet_nocc */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      break;

    case GT:
      res = recog_35 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case GE:
      res = recog_36 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case NE:
      res = recog_37 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      res = recog_54 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  switch (GET_CODE (x2))
    {
    case NE:
    case EQ:
    case GE:
    case GT:
    case LE:
    case LT:
    case LTGT:
    case GEU:
    case GTU:
    case LEU:
    case LTU:
    case UNORDERED:
    case ORDERED:
    case UNEQ:
    case UNGE:
    case UNGT:
    case UNLE:
    case UNLT:
      operands[1] = x2;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern45 (x2))
        {
        case 0:
          if (!(
#line 7287 "../../gcc/config/s390/s390.md"
(TARGET_Z13) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2321; /* *cstoreccdi_z13 */

        case 1:
          if (!
#line 7287 "../../gcc/config/s390/s390.md"
(TARGET_Z13))
            return -1;
          return 2322; /* *cstoreccsi_z13 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (pattern212 (x2) != 0)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) == E_CCL1mode)
    {
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) == E_CCL1mode)
        {
          x6 = XEXP (x5, 1);
          if (rtx_equal_p (x6, operands[1]))
            {
              x7 = XEXP (x5, 0);
              switch (GET_MODE (x7))
                {
                case E_DImode:
                  if (pattern276 (x1, 
E_DImode) == 0
                      && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
                    return 2298; /* adddi3_alc_carry1_cc */
                  break;

                case E_SImode:
                  if (pattern276 (x1, 
E_SImode) == 0)
                    return 2299; /* addsi3_alc_carry1_cc */
                  break;

                default:
                  break;
                }
            }
        }
    }
  x5 = XEXP (x3, 1);
  x6 = XEXP (x5, 1);
  if (!rtx_equal_p (x6, operands[2]))
    return -1;
  x7 = XEXP (x5, 0);
  switch (GET_MODE (x7))
    {
    case E_DImode:
      if (pattern276 (x1, 
E_DImode) != 0
          || !(
#line 7060 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
        return -1;
      return 2302; /* *adddi3_alc_carry2_cc */

    case E_SImode:
      if (pattern276 (x1, 
E_SImode) != 0
          || !
#line 7060 "../../gcc/config/s390/s390.md"
(s390_match_ccmode (insn, CCL1mode)))
        return -1;
      return 2303; /* *addsi3_alc_carry2_cc */

    default:
      return -1;
    }
}

 int
recog_90 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  x6 = XEXP (x5, 1);
  operands[2] = x6;
  x7 = XEXP (x4, 1);
  operands[3] = x7;
  x8 = XVECEXP (x1, 0, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x8, 1);
  x11 = XEXP (x10, 1);
  if (!rtx_equal_p (x11, operands[2]))
    return -1;
  switch (GET_MODE (x5))
    {
    case E_DImode:
      if (pattern289 (x10, 
E_DImode) != 0
          || !
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH))
        return -1;
      *pnum_clobbers = 1;
      return 2551; /* *brx_stage1_di */

    case E_SImode:
      if (pattern289 (x10, 
E_SImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 2552; /* *brx_stage1_si */

    default:
      return -1;
    }
}

 int
recog_94 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (pattern38 (x1) != 0)
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (pattern121 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 8153 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2373; /* *andhi3_zarch */
      if (!
#line 8170 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2374; /* *andhi3_esa */

    case E_QImode:
      if (pattern121 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 8198 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return 2375; /* *andqi3_zarch */
      if (!
#line 8215 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
        return -1;
      return 2376; /* *andqi3_esa */

    default:
      return -1;
    }
}

 int
recog_96 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case PLUS:
    case MINUS:
    case MULT:
    case AND:
    case SIGN_EXTEND:
    case ZERO_EXTEND:
    case HIGH:
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
          if (XWINT (x5, 0) == 2147483647L
              && pattern38 (x1) == 0
              && register_operand (operands[0], E_SImode)
              && GET_MODE (x3) == E_SImode)
            {
              operands[1] = x4;
              if (address_operand (operands[1], E_QImode)
                  && 
#line 2589 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return 1869; /* *la_31_and_cc */
            }
          break;

        case REG:
        case SUBREG:
        case MEM:
          res = recog_93 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        default:
          break;
        }
      operands[1] = x4;
      res = recog_94 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != REG
          || REGNO (x7) != 33
          || GET_MODE (x7) != E_CCmode)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      if (GET_CODE (x4) == SUBREG)
        {
          res = recog_95 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
        }
      operands[1] = x4;
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern121 (x3, 
E_DImode) != 0
              || !
#line 7961 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2360; /* *anddi3 */

        case E_SImode:
          if (pattern121 (x3, 
E_SImode) != 0)
            return -1;
          if (
#line 8090 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return 2371; /* *andsi3_zarch */
          if (!
#line 8124 "../../gcc/config/s390/s390.md"
(!TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2372; /* *andsi3_esa */

        default:
          return -1;
        }

    case ROTATE:
      if (GET_MODE (x4) != E_DImode
          || pattern38 (x1) != 0
          || !register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_DImode))
        return -1;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      if (!const_int_operand (operands[2], E_DImode))
        return -1;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      if (!contiguous_bitmask_operand (operands[3], E_DImode)
          || !
#line 4404 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12))
        return -1;
      return 1963; /* *risbg_di_and_rot */

    case LSHIFTRT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern89 (x6) != 0)
        return -1;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
        case MEM:
          operands[4] = x5;
          if (!nonimmediate_operand (operands[4], E_DImode))
            return -1;
          x8 = XEXP (x2, 0);
          if (GET_CODE (x8) != ZERO_EXTRACT
              || GET_MODE (x8) != E_DImode)
            return -1;
          x11 = XEXP (x8, 0);
          operands[0] = x11;
          if (!nonimmediate_operand (operands[0], E_DImode))
            return -1;
          x12 = XEXP (x8, 1);
          operands[1] = x12;
          if (!const_int_operand (operands[1], E_VOIDmode))
            return -1;
          x13 = XEXP (x8, 2);
          operands[2] = x13;
          if (!const_int_operand (operands[2], E_VOIDmode)
              || GET_MODE (x3) != E_DImode
              || GET_MODE (x4) != E_DImode)
            return -1;
          x10 = XEXP (x4, 1);
          operands[3] = x10;
          if (!const_int_operand (operands[3], E_VOIDmode))
            return -1;
          x9 = XEXP (x4, 0);
          if (!rtx_equal_p (x9, operands[0])
              || !
#line 4850 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && EXTRACT_ARGS_IN_RANGE (INTVAL (operands[1]), INTVAL (operands[2]), 64)
   && INTVAL (operands[3]) == 64 - INTVAL (operands[1]) - INTVAL (operands[2])))
            return -1;
          return 2017; /* *insv_rnsbg_srl */

        case CONST_INT:
          operands[3] = x5;
          x8 = XEXP (x2, 0);
          operands[0] = x8;
          x9 = XEXP (x4, 0);
          operands[1] = x9;
          x10 = XEXP (x4, 1);
          operands[2] = x10;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern245 (x3, 
E_DImode) != 0
                  || !(
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (64, -INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2362; /* *extzv_di_srl_clobbercc */

            case E_SImode:
              if (pattern245 (x3, 
E_SImode) != 0
                  || !
#line 8011 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   /* Note that even for the SImode pattern, the rotate is always DImode.  */
   && s390_extzv_shift_ok (32, -INTVAL (operands[2]),
			   INTVAL (operands[3]))))
                return -1;
              return 2364; /* *extzv_si_srl_clobbercc */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x10 = XEXP (x4, 1);
      operands[2] = x10;
      x5 = XEXP (x3, 1);
      operands[3] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern245 (x3, 
E_DImode) != 0
              || !(
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (64, INTVAL (operands[2]),
			   INTVAL (operands[3]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2366; /* *extzv_di_sll_clobbercc */

        case E_SImode:
          if (pattern245 (x3, 
E_SImode) != 0
              || !
#line 8025 "../../gcc/config/s390/s390.md"
(TARGET_Z10 && ! TARGET_ZEC12
   && s390_extzv_shift_ok (32, INTVAL (operands[2]),
			   INTVAL (operands[3]))))
            return -1;
          return 2368; /* *extzv_si_sll_clobbercc */

        default:
          return -1;
        }

    case NOT:
      x6 = XVECEXP (x1, 0, 1);
      if (pattern39 (x6) != 0)
        return -1;
      x8 = XEXP (x2, 0);
      operands[0] = x8;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case CONST_INT:
        case CONST_WIDE_INT:
        case CONST_POLY_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
        case CONST_VECTOR:
        case CONST:
        case REG:
        case SUBREG:
        case MEM:
        case LABEL_REF:
        case SYMBOL_REF:
        case HIGH:
          operands[2] = x5;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (GET_MODE (x3) != E_DImode
                  || GET_MODE (x4) != E_DImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_DImode)
                  && nonimmediate_operand (operands[1], E_DImode)
                  && general_operand (operands[2], E_DImode)
                  && (
#line 8233 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return 2377; /* *andc_split_di */
              if (!register_operand (operands[0], E_DImode)
                  || !register_operand (operands[1], E_DImode)
                  || !register_operand (operands[2], E_DImode)
                  || !(
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2399; /* *andcdi */

            case E_SImode:
              if (GET_MODE (x3) != E_SImode
                  || GET_MODE (x4) != E_SImode)
                return -1;
              if (nonimmediate_operand (operands[0], E_SImode)
                  && nonimmediate_operand (operands[1], E_SImode)
                  && general_operand (operands[2], E_SImode)
                  && 
#line 8233 "../../gcc/config/s390/s390.md"
(!TARGET_Z15
   && ! reload_completed
   && (GET_CODE (operands[0]) != MEM
      /* Ensure that s390_logical_operator_ok_p will succeed even
	 on the split xor if (b & a) is stored into a pseudo.  */
       || rtx_equal_p (operands[0], operands[2]))))
                return 2378; /* *andc_split_si */
              if (!register_operand (operands[0], E_SImode)
                  || !register_operand (operands[1], E_SImode)
                  || !register_operand (operands[2], E_SImode)
                  || !
#line 8612 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2401; /* *andcsi */

            default:
              return -1;
            }

        case NOT:
          switch (pattern215 (x3))
            {
            case 0:
              if (!(
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 2411; /* *nordi */

            case 1:
              if (!
#line 8652 "../../gcc/config/s390/s390.md"
(TARGET_Z15))
                return -1;
              return 2413; /* *norsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_108 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  operands[0] = x3;
  x4 = XEXP (x2, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case AND:
      switch (pattern93 (x1))
        {
        case 0:
          x6 = XEXP (x4, 1);
          operands[3] = x6;
          switch (GET_MODE (operands[0]))
            {
            case E_DImode:
              if (pattern249 (x4, 
E_DImode) != 0
                  || !(
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
                return -1;
              return 1993; /* *rxsbg_di_noshift */

            case E_SImode:
              if (pattern249 (x4, 
E_SImode) != 0
                  || !
#line 4685 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
                return -1;
              return 1995; /* *rxsbg_si_noshift */

            default:
              return -1;
            }

        case 1:
          if (!
#line 4700 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 1997; /* *rxsbg_di_rotl */

        case 2:
          if (!(
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 1999; /* *rxsbg_di_srl_bitmask */

        case 3:
          if (!
#line 4715 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, 64 - INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 2001; /* *rxsbg_si_srl_bitmask */

        case 4:
          if (!(
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (64, INTVAL (operands[3]),
                           INTVAL (operands[2]))) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2003; /* *rxsbg_di_sll_bitmask */

        case 5:
          if (!
#line 4735 "../../gcc/config/s390/s390.md"
(TARGET_Z10
   && s390_extzv_shift_ok (32, INTVAL (operands[3]),
                           INTVAL (operands[2]))))
            return -1;
          return 2005; /* *rxsbg_si_sll_bitmask */

        default:
          return -1;
        }

    case ASHIFT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2007; /* *rxsbg_di_sll */

        case 1:
          if (!
#line 4753 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2009; /* *rxsbg_si_sll */

        default:
          return -1;
        }

    case LSHIFTRT:
      switch (pattern96 (x1))
        {
        case 0:
          if (!(
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return -1;
          return 2011; /* *rxsbg_di_srl */

        case 1:
          if (!
#line 4772 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
            return -1;
          return 2013; /* *rxsbg_si_srl */

        default:
          return -1;
        }

    case REG:
    case SUBREG:
    case MEM:
      if (GET_CODE (x5) == SUBREG
          && pattern119 (x1) == 0
          && 
#line 4792 "../../gcc/config/s390/s390.md"
(TARGET_Z10))
        return 2015; /* *rxsbg_sidi_srl */
      if (pnum_clobbers != NULL
          && pattern120 (x1) == 0
          && 
#line 8948 "../../gcc/config/s390/s390.md"
(INTVAL (operands[2]) >= 1 && INTVAL (operands[2]) <= 256))
        {
          *pnum_clobbers = 1;
          return 2426; /* *xc */
        }
      operands[1] = x5;
      switch (pattern122 (x1))
        {
        case 0:
          if (!
#line 8792 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH && s390_logical_operator_ok_p (operands)))
            return -1;
          return 2420; /* *xordi3 */

        case 1:
          if (!
#line 8862 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2423; /* *xorsi3 */

        case 2:
          if (!
#line 8895 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2424; /* *xorhi3 */

        case 3:
          if (!
#line 8925 "../../gcc/config/s390/s390.md"
(s390_logical_operator_ok_p (operands)))
            return -1;
          return 2425; /* *xorqi3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_116 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case CLOBBER:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != CLOBBER)
        return -1;
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != SET)
        return -1;
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != USE)
        return -1;
      x6 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x6) != USE)
        return -1;
      x7 = XEXP (x2, 0);
      operands[0] = x7;
      x8 = XEXP (x3, 0);
      operands[1] = x8;
      x9 = XEXP (x4, 1);
      switch (GET_CODE (x9))
        {
        case MEM:
          if (pnum_clobbers == NULL
              || pattern98 (x4) != 0)
            return -1;
          switch (pattern257 (x1))
            {
            case 0:
              if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1906; /* *cpymem_long */

            case 1:
              if (!(
#line 3698 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              *pnum_clobbers = 1;
              return 1907; /* *cpymem_long */

            case 2:
              if (!
#line 3711 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              *pnum_clobbers = 1;
              return 1908; /* *cpymem_long_31z */

            default:
              return -1;
            }

        case COMPARE:
          if (GET_MODE (x9) != E_CCUmode)
            return -1;
          x10 = XEXP (x9, 0);
          if (GET_CODE (x10) != MEM
              || GET_MODE (x10) != E_BLKmode)
            return -1;
          x11 = XEXP (x10, 0);
          if (GET_CODE (x11) != SUBREG)
            return -1;
          x12 = XEXP (x9, 1);
          if (GET_CODE (x12) != MEM
              || GET_MODE (x12) != E_BLKmode)
            return -1;
          x13 = XEXP (x12, 0);
          if (GET_CODE (x13) != SUBREG)
            return -1;
          x14 = XEXP (x4, 0);
          if (GET_CODE (x14) != REG
              || REGNO (x14) != 33
              || GET_MODE (x14) != E_CCUmode)
            return -1;
          x15 = XEXP (x11, 0);
          operands[2] = x15;
          x16 = XEXP (x13, 0);
          operands[3] = x16;
          x17 = XEXP (x5, 0);
          if (!rtx_equal_p (x17, operands[2]))
            return -1;
          x18 = XEXP (x6, 0);
          if (!rtx_equal_p (x18, operands[3]))
            return -1;
          switch (SUBREG_BYTE (x11))
            {
            case 0:
              if (maybe_ne (SUBREG_BYTE (x13), 0))
                return -1;
              switch (GET_MODE (operands[0]))
                {
                case E_TImode:
                  if (pattern295 (x9, 
E_TImode, 
E_DImode) != 0
                      || !(
#line 4151 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                    return -1;
                  return 1928; /* *cmpmem_long */

                case E_DImode:
                  if (pattern295 (x9, 
E_DImode, 
E_SImode) != 0
                      || !(
#line 4151 "../../gcc/config/s390/s390.md"
(TARGET_64BIT || !TARGET_ZARCH) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                    return -1;
                  return 1929; /* *cmpmem_long */

                default:
                  return -1;
                }

            case 4:
              if (GET_MODE (x11) != E_SImode
                  || maybe_ne (SUBREG_BYTE (x13), 4)
                  || GET_MODE (x13) != E_SImode
                  || !register_operand (operands[0], E_TImode)
                  || !register_operand (operands[1], E_TImode)
                  || !register_operand (operands[2], E_TImode)
                  || !register_operand (operands[3], E_TImode)
                  || !
#line 4164 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT && TARGET_ZARCH))
                return -1;
              return 1930; /* *cmpmem_long_31z */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SET:
      x4 = XVECEXP (x1, 0, 2);
      if (GET_CODE (x4) != USE)
        return -1;
      x19 = XEXP (x2, 1);
      switch (GET_CODE (x19))
        {
        case CONST_INT:
          if (XWINT (x19, 0) != 0L)
            return -1;
          x3 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x3) != USE
              || pattern103 (x1) != 0
              || !nonmemory_operand (operands[1], E_VOIDmode))
            return -1;
          x14 = XEXP (x4, 0);
          operands[2] = x14;
          if (!immediate_operand (operands[2], E_VOIDmode))
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          x17 = XEXP (x5, 0);
          operands[3] = x17;
          switch (GET_MODE (operands[3]))
            {
            case E_DImode:
              if (!scratch_operand (operands[3], E_DImode)
                  || !(
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT)))
                return -1;
              return 1918; /* *clrmem_short */

            case E_SImode:
              if (!scratch_operand (operands[3], E_SImode)
                  || !(
#line 3849 "../../gcc/config/s390/s390.md"
((GET_MODE (operands[1]) == Pmode || GET_MODE (operands[1]) == VOIDmode)) && 
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT)))
                return -1;
              return 1919; /* *clrmem_short */

            default:
              return -1;
            }

        case LABEL_REF:
          if (pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[2] = x20;
          switch (pattern271 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2679; /* split_stack_calldi */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2680; /* split_stack_callsi */

            default:
              return -1;
            }

        case IF_THEN_ELSE:
          x21 = XEXP (x19, 1);
          if (GET_CODE (x21) != LABEL_REF)
            return -1;
          x22 = XEXP (x19, 2);
          if (GET_CODE (x22) != PC
              || pattern79 (x1) != 0)
            return -1;
          x20 = XEXP (x19, 0);
          operands[5] = x20;
          x23 = XEXP (x21, 0);
          operands[2] = x23;
          switch (pattern271 (x1))
            {
            case 0:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(TARGET_64BIT))
                return -1;
              return 2681; /* split_stack_cond_calldi */

            case 1:
              if (!
#line 778 "../../gcc/config/s390/s390.md"
(!TARGET_64BIT))
                return -1;
              return 2682; /* split_stack_cond_callsi */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_4 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case AND:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_148 (insn, operands);

        case 1:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_157 (insn, operands);

        case 2:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_166 (insn, operands);

        case 3:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_175 (insn, operands);

        case 4:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_184 (insn, operands);

        case 5:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_193 (insn, operands);

        case 6:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 7:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_211 (insn, operands);

        case 8:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_220 (insn, operands);

        case 9:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_229 (insn, operands);

        case 10:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_238 (insn, operands);

        case 11:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_247 (insn, operands);

        case 12:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_256 (insn, operands);

        case 13:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_265 (insn, operands);

        case 14:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_274 (insn, operands);

        case 15:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_283 (insn, operands);

        default:
          return NULL;
        }

    case IOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_149 (insn, operands);

        case 1:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_158 (insn, operands);

        case 2:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_167 (insn, operands);

        case 3:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_176 (insn, operands);

        case 4:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_185 (insn, operands);

        case 5:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 6:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 7:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_212 (insn, operands);

        case 8:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_221 (insn, operands);

        case 9:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_230 (insn, operands);

        case 10:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_239 (insn, operands);

        case 11:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_248 (insn, operands);

        case 12:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_257 (insn, operands);

        case 13:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_266 (insn, operands);

        case 14:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_275 (insn, operands);

        case 15:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_284 (insn, operands);

        default:
          return NULL;
        }

    case XOR:
      switch (pattern29 (x3))
        {
        case 0:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_150 (insn, operands);

        case 1:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_159 (insn, operands);

        case 2:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_168 (insn, operands);

        case 3:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_177 (insn, operands);

        case 4:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_186 (insn, operands);

        case 5:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 6:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_204 (insn, operands);

        case 7:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_213 (insn, operands);

        case 8:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_222 (insn, operands);

        case 9:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_231 (insn, operands);

        case 10:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_240 (insn, operands);

        case 11:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_249 (insn, operands);

        case 12:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_258 (insn, operands);

        case 13:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_267 (insn, operands);

        case 14:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_276 (insn, operands);

        case 15:
          if (!(
#line 3543 "../../gcc/config/s390/vector.md"
(TARGET_VXE3) && 
#line 3545 "../../gcc/config/s390/vector.md"
( true)))
            return NULL;
          return gen_split_285 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != ASHIFT)
        return NULL;
      x6 = XEXP (x4, 0);
      operands[1] = x6;
      x7 = XEXP (x4, 1);
      operands[2] = x7;
      x8 = XEXP (x5, 0);
      operands[3] = x8;
      x9 = XEXP (x5, 1);
      operands[4] = x9;
      switch (GET_MODE (operands[0]))
        {
        case E_DImode:
          if (pattern182 (x3, 
E_DImode) != 0
              || !(
#line 4631 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 64) && 
#line 771 "../../gcc/config/s390/s390.md"
(TARGET_ZARCH)))
            return NULL;
          return gen_split_346 (insn, operands);

        case E_SImode:
          if (pattern182 (x3, 
E_SImode) != 0
              || !
#line 4631 "../../gcc/config/s390/s390.md"
(TARGET_ZEC12 && UINTVAL (operands[2]) + UINTVAL (operands[4]) >= 32))
            return NULL;
          return gen_split_347 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
peephole2_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pmatch_len_ ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (!memory_operand (operands[0], E_BLKmode)
      || !memory_operand (operands[1], E_BLKmode))
    return NULL;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[2] = x3;
  if (!const_int_operand (operands[2], E_VOIDmode))
    return NULL;
  x4 = PATTERN (peep2_next_insn (1));
  if (pattern196 (x4, 
2) != 0)
    return NULL;
  x5 = XVECEXP (x4, 0, 0);
  x6 = XEXP (x5, 0);
  operands[3] = x6;
  if (!memory_operand (operands[3], E_BLKmode))
    return NULL;
  x7 = XEXP (x5, 1);
  operands[4] = x7;
  if (!memory_operand (operands[4], E_BLKmode))
    return NULL;
  x8 = XVECEXP (x4, 0, 1);
  x9 = XEXP (x8, 0);
  operands[5] = x9;
  if (!const_int_operand (operands[5], E_VOIDmode)
      || !
#line 3142 "../../gcc/config/s390/s390.md"
(((INTVAL (operands[2]) > 16 && INTVAL (operands[5]) > 16)
    || (INTVAL (operands[2]) + INTVAL (operands[5]) <= 16))
   && s390_offset_p (operands[0], operands[3], operands[2])
   && s390_offset_p (operands[1], operands[4], operands[2])
   && !s390_overlap_p (operands[0], operands[1],
                       INTVAL (operands[2]) + INTVAL (operands[5]))
   && INTVAL (operands[2]) + INTVAL (operands[5]) <= 256))
    return NULL;
  *pmatch_len_ = 1;
  return gen_peephole2_18 (insn, operands);
}
